﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.diapo.fromFolder {	
	import flash.events.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.mvc.AbstractControler;		
	import net.flash_line.as3.diapo.fromFolder.graph.Thumb ;
	import net.flash_line.as3.util.ui.bubble.BubbleInfoFixed ;
	import net.flash_line.as3.util.io.progress.ProgressBarMng;
	import net.flash_line.as3.diapo.fromFolder.OneModel;
	import net.flash_line.as3.util.io.BatchLoader;
	import net.flash_line.as3.util.io.LoaderSprite;
	import net.flash_line.as3.util.ui.scroll.ScrollFrame;
	//
	import net.flash_line.as3.diapo.fromFolder.OneModel;
	//
	/**
	* application's Controler
	*/
	class Controler extends AbstractControler {
		
		private var pIdle:Boolean=false;
		private var pIsOnPause:Boolean;
		private var pIsBarFixed:Boolean;		
		private var pIsClose:Boolean;
		private var pLs:LoaderSprite;
		private var pScrollMng:ScrollFrame;
		private var pDelHide:Delay2;
		private var pBl:BatchLoader;
		private var pbm:ProgressBarMng;
		/**
		* constructor
		* @param	mn Main instance
		* @param	m Model instance
		* @param	v View instance
		*/
		public function Controler (mn:Main) {
			super(mn);
			setClassInfo("Controler",this);	
		}
		/**
		* @return Main instance
		*/
		public function get main ():Main {
			return super._main;
		}
		
		public function get model (): Model {
			return main.model;
		}
		public function get view ():View {
			return main.view;
		}
		//
		public function get isClose () : Boolean {
			return pIsClose;
		}
		/**
		* Method called when xml model and skin,
		* are loaded.
		* It's the subclass real begining
		*/
		override public function onFirstAppliEvent () {		
			pbm = new ProgressBarMng(view.parentCtnr,model.progressBarMng, ProgressBarMng.ON_LOAD_PROGRESS);
			pbm.addEventListener("onLoadSwfSkin", loadLanguage);
			pbm.loadModel();
			
		}
		public function loadLanguage (e:Event) {
			model.addEventListener("onLoadLanguage",fOnLoadLanguage);
			model.loadLanguage();
		}
		/**
		* remove info bubbles - event sources and listeners
		* <p>this method may be used at beginning to disable and may be change info bubble system.</p>
		*/			
		public function removeBubble () {
			stack.clear("disable");			
		}		
		/**
		* create info bubbles - event sources and listeners
		* <p> this method may be used to restart info bubble system after a previous removeBubble() call.</p>
		*/			
		public function createBubble () {			
			// remove previous
			removeBubble();		
			createOneBubble (view.playClick,"playPause");
			createOneBubble (view.fullScreenClick,"fullScreen");
			if (model.autoHide) createOneBubble (view.pins,"barBlocking");
			createOneBubble (view.next,"next");
			createOneBubble (view.prev,"prev");
			createOneBubble (view.openClose,"openClose");			
			//createOneBubble (view.bar,"about",param.lang.aboutBubble.title+getGlobalVar().version);
		}
		/**
		* create one info bubbles - event sources and listeners
		* <p>this method may be used at beginning to add an other button in info bubble system.</p>
		* @param	spx		Sprite which will start bubble info when user rollOver it
		* @param	id		Id in model.xml config file.
		* @param	title	used only for "about" id.
		*/
		public function createOneBubble (spx:SpriteX,id:String,title:String="") {			
			var vx:Number=view.firstImage.x; 
			var vy:Number=view.firstImage.y; 
			var w:Number=view.firstImage.width;
			var ctnr:SpriteX=view.parentCtnr;
			//
			var t:Number=numVal(param.bubble[id].tween) ; 
			var d:Number=numVal(param.bubble[id].delay) ;
			var a:Number=numVal(param.bubble[id].alpha ) ; 
			var h:Number=numVal(param.bubble[id].height)  ;
			//
			if ( t==0 ) t=N(param.bubble.tween) ;
			if ( d==0 ) d=N(param.bubble.delay) ; 
			if ( a==0 ) a=N(param.bubble.alpha) ;
			if ( h==0 ) h=N(param.bubble.height) ;
			// 			
			var lab:String=title+param.lang[id+"Bubble"].label;		
			stack.push(new BubbleInfoFixed(ctnr,spx,lab,vx,vy,w,h,d,t,a));			
		}
		//
		private function fOnLoadLanguage (ex:EventX) {					
			view.createScrollBox();
			pIsOnPause=(param.start.beginOnPause=="true");
			pIsClose=false;pIsBarFixed=false;
			createResizeListener();			
			view.init(!pIsOnPause,false,true);
			reStart();
		}		
		private function reStart () {
			if (model.autoHide) createAutoHideListener();
			locateAndResize(new Event("null"));
			view.showSkin();
			model.addEventListener(EventX.ON_LOAD_XML,fOnLoadImgXml);
			model.loadImageModel ();
		}		
		// private
		private function fOnLoadImgXml (e:EventX) {
			model.removeEventListener(EventX.ON_LOAD_XML,fOnLoadImgXml);			
			loadThumb();
		}		
		private function loadThumb () {				
			var imgMrg:Number=N(param.scroll.thumb.image.margin);
			var nc:Number=numVal(param.scroll.thumb.colNum,2);
			var w:Number=N(param.scroll.thumb.width);
			var h:Number=N(param.scroll.thumb.height);
			pBl = new BatchLoader(model.baseUrl) ;
			var vy:Number=0-numVal(param.scroll.thumb.stepY,84);
			var vx:Number=0;//-numVal(param.scroll.thumb.stepX,118);			
			var len:Number=model.imageList.length;
			for (var i=0;i<len;i++) {
				var om:OneModel=model.imageList[i];
				if (i%nc==0 ) { vx=0 ; vy+=numVal(param.scroll.thumb.stepY,84) ; }
				else vx+=numVal(param.scroll.thumb.stepX,118);				 
				om.thumbSpx=view.getNewEmptyThumb(vx,vy,w,h);
				om.thumbSpx.over.visible=false;
				if (om.thumb=="" ) om.thumb=om.src ;
				if (om.type!="folder") {
					pBl.push(om.thumbSpx.image,om.thumb,"",null,null,w-imgMrg*2,h-imgMrg*2,true );
				} else {
					if (om.name=="..") {
						pBl.push(om.thumbSpx.image,param.scroll.thumb.previousImg.src,"",0,0,w-imgMrg*2,h-imgMrg*2 );
					} else {
						pBl.push(om.thumbSpx.image,param.scroll.thumb.folderImg.src,"",0,0,w-imgMrg*2,h-imgMrg*2 );
						om.thumbSpx.tf.setText(om.title,{align:"center"});
					}
				}
			}
			pBl.addEventListener(EventX.ON_LOAD_BATCH,fOnLoadThumb);
			pBl.addEventListener(EventX.ON_LOAD_ERROR,fOnLoadErrorThumb);
			pBl.load(N(param.application.timeOut));	
			pbm.alpha = 1;
			pbm.title = param.lang.progressBarTitle.thumb.label;
			pbm.startProgress(pBl);
		}
		private function fOnLoadErrorThumb (e:EventX) {
			pbm.hide();
			error(param.lang.error.thumbLoad.label);
		}
		private function fOnLoadThumb (e:EventX) {
			pBl.removeEventListener("onLoadBatch",fOnLoadThumb);
			view.createBgInScrollContainer();
			createInteractiveListener(); 
			// test folderOnly
			if (model.imageList.folderOnly) {
				view.playPause.visible=false;
				view.displayTitle(param.lang.titleFolderOnly.label);
			} else {
				view.playPause.visible=true;		
			}
			//
			// start images auto display
			if (!pIsOnPause) {
				setPlayState();
				play();				
			} else {
				setPauseState();
				pause();
			}
			// create right navig scroll
			createScrollMng();
			// Create event on each thumb
			for (var i=0;i<model.imageList.length;i++) {		
				var om:OneModel=model.imageList[i];
				om.thumbSpx.addEventListener(MouseEvent.CLICK,Delegate.pass(fClickThumb,om));
				om.thumbSpx.addEventListener(MouseEvent.ROLL_OVER,Delegate.pass(fOverThumb,om));
				om.thumbSpx.addEventListener(MouseEvent.ROLL_OUT,fOutThumb);				
			}
			fOutThumb(new MouseEvent("null"));
		}
		private function fClickThumb(e:MouseEvent,om:OneModel) {
			if (pIdle) return;			
			if (om.type!="folder"){
				model.currIndex=om.index-1;
				nextImage(new Event(""));
				if (param.scroll.thumb.pauseWhenClick == "true") {
					pause();
					setPauseState ();
				}
			} else {
				if (om.name=="..") {
					model.folderStk.pop();
				} else {
					model.folderStk.push(om.name+"/");
				}					
				clear();
				reStart();				
			}
		}
		
		private function fOverThumb(e:MouseEvent,om:OneModel) {
			view.lightOnThumb(om.thumbSpx);
			om.thumbSpx.over.visible=true ; 
		}
		private function fOutThumb(e:MouseEvent) {
			showSelectedThumb(model.currImg);
		}
		private function showSelectedThumb(om:OneModel=null) {	
			//de-select all thumbs			
			for (var i=0;i<model.imageList.length;i++) {
				var o:OneModel = model.imageList[i];
				view.lightOffThumb(o.thumbSpx);				
			}
			// select the thumb	
			if (om!=null) {
				view.lightOnThumb(om.thumbSpx);					
			}
		}
		private function pause() {
			if (clock!=null) clock=clock.remove();
			pIsOnPause=true;
		}
		private function play() {
			pIsOnPause=false;
			if (clock!=null) clock=clock.remove();
			clock=new Clock(nextImage,N(param.application.delay));
			nextImage(new Event(""));
		}
		private function prevImage() {
			if (pIdle || model.imageList.folderOnly ) return ;			
			model.currIndex--;	
			if (model.currIndex<0) model.currIndex=model.imageList.length-1;
			model.currImg = model.imageList[model.currIndex] ;
			if (model.currImg.type=="folder") {
				prevImage();
			} else {
				loadImage();	
				showSelectedThumb(model.currImg);
			}
		}
		private function nextImage(e:Event) {
			if (pIdle || model.imageList.folderOnly ) return ;			
			model.currIndex++;			
			if (model.currIndex>model.imageList.length-1) model.currIndex=0;			
			model.currImg = model.imageList[model.currIndex] ;
			if (model.currImg.type=="folder") {
				nextImage(new Event(""));
			} else {
				loadImage();	
				showSelectedThumb(model.currImg);
			}
		}
		private function loadImage()  {
			pIdle=true;
			pLs = new LoaderSprite(view.target, model.currImg.src);
			pbm.alpha = .5;
			pbm.title = param.lang.progressBarTitle.image.label;
			pbm.startProgress(pLs);
			pLs.addEventListener(EventX.ON_LOAD_COMPLETE,fDisplayImage);	
			pLs.addEventListener(EventX.ON_LOAD_ERROR,fOnErrorImage);
		}
		private function fDisplayImage(ex:EventX)  {
			model.currImg.imageSpx=pLs;
			pLs.removeEventListener(EventX.ON_LOAD_COMPLETE,fDisplayImage);
			pLs.removeEventListener(EventX.ON_LOAD_ERROR,fOnErrorImage);
			view.addEventListener(EventX.ON_IMAGE_DISPLAY,fOnImageDisplay);
			view.displayImage(pLs);			
			//view.displayTitle(param.lang.folder.label+model.getFolderPath()+param.lang.title.label+model.currImg.title);
			view.displayTitle(param.lang.folder.label,model.getFolderPath(),param.lang.title.label,model.currImg.title);
			
		}
		private function fOnImageDisplay(ex:EventX)  {
			view.removeEventListener(EventX.ON_IMAGE_DISPLAY,fOnImageDisplay);
			pIdle=false;
		}
		private function fOnErrorImage(ex:EventX)  {
			pIdle=false;
			pLs.removeEventListener(EventX.ON_LOAD_COMPLETE,fDisplayImage);
			pLs.removeEventListener(EventX.ON_LOAD_ERROR,fOnErrorImage);
		}
		private function createInteractiveListener() {		
			view.playClick.addEventListener(MouseEvent.CLICK,fClickPlayOrPause);			
			if (model.imageList.folderOnly) {
				view.playPause.visible=false;
			} else {
				view.playPause.visible=true;		
			}
			// fs
			view.fullScreenClick.addEventListener(MouseEvent.CLICK,fClickFullScreen);	
			//
			if (model.mayBeClosed) view.openClose.addEventListener(MouseEvent.CLICK,fClickOpenClose);	
			if (model.autoHide && view.pins!=null) {
				view.pinsClick.addEventListener(MouseEvent.CLICK,fClickPins);
			}
			view.next.addEventListener(MouseEvent.CLICK,fClickNext);
			view.prev.addEventListener(MouseEvent.CLICK,fClickPrev);
			// central area
			var spx:SpriteX=view.getCentralArea();
			spx.addEventListener(MouseEvent.CLICK,fClickFullScreen);
			// bubbles
			createBubble();
		}
		private function createResizeListener () {			
			view.stage.addEventListener(Event.RESIZE, locateAndResize);			
		}
		private function createAutoHideListener () {
			if (model.autoHide && (!pIsBarFixed) && ( view.fullScreenIsOn || !model.autoHideOnlyWhenFullScreen) ) {
				removeAutoHideListener () ;
				view.bar.removeEventListener(MouseEvent.ROLL_OVER,fOverBottomBar);
				view.bar.removeEventListener(MouseEvent.ROLL_OUT,fOutBottomBar);
				pDelHide=new Delay2(model.delayHide);
				pDelHide.addEventListener(EventX.ON_DELAY,fHideBottomBar);
				view.bar.addEventListener(MouseEvent.ROLL_OVER,fOverBottomBar);
				view.bar.addEventListener(MouseEvent.ROLL_OUT, fOutBottomBar);
			}
		}
		private function removeAutoHideListener () {			
			if (pDelHide!=null) {
				pDelHide.removeEventListener(EventX.ON_DELAY,fHideBottomBar);
				pDelHide=pDelHide.remove();
			}
		}
		private function fClickNext (e:MouseEvent) {
			nextImage(new Event(""));
		}
		private function fClickPrev (e:MouseEvent) {
			prevImage();
		}
		private function fOverBottomBar (e:MouseEvent) {
			removeAutoHideListener () ;
		}
		private function fOutBottomBar (e:MouseEvent) {
			 createAutoHideListener ();
		}
		private function fHideBottomBar (ex:EventX) {			
			removeAutoHideListener () ;
			//view.bar.removeEventListener(MouseEvent.ROLL_OVER,fOverBottomBar);	
			//view.bar.removeEventListener(MouseEvent.ROLL_OUT,fOutBottomBar);				
			view.hideBottomBar();
			view.hiddenBar.addEventListener(MouseEvent.ROLL_OVER,fOverHiddenBar);			
		}
		private function fOverHiddenBar (e:MouseEvent) {
			view.hiddenBar.removeEventListener(MouseEvent.ROLL_OVER,fOverHiddenBar);
			view.restoreBottomBar();	
		}
		private function locateAndResize (e:Event) {			
			view.locateAndResize();
			createScrollMng();
		}		
		private function createScrollMng () {
			if (pScrollMng!=null) pScrollMng.remove();
			pScrollMng=new ScrollFrame(view.scrollContainer,view.scrollUpBar,view.scrollDownBar,view.scrollMsk);
			view.showHideScroll();
		}
		
		private function fClickPins(e:Event) {
			pIsBarFixed=!pIsBarFixed;
			if (pIsBarFixed) {
				view.pinsOn.visible=true;			
				view.pinsOff.visible=false;	
				removeAutoHideListener () ;
			} else {
				view.pinsOff.visible=true;			
				view.pinsOn.visible=false;	
				createAutoHideListener () ;
			}			
		}
		private function fClickFullScreen(e:Event) {
			if (view.fullScreenIsOn) {
				view.setNormalScreen();	
				setFullScreenStateOff ();
			} else {
				view.setFullScreen();
				setFullScreenStateOn();
			}
		}
		/// fullscreen/normalscreen
		private function setFullScreenStateOff () {
			view.fullScreenOn.visible=true;			
			view.fullScreenOff.visible = false;
			if (model.autoHide && model.autoHideOnlyWhenFullScreen ) removeAutoHideListener () ;
		}
		private function setFullScreenStateOn () {
			view.fullScreenOn.visible=false;			
			view.fullScreenOff.visible = true;
			if (model.autoHide && model.autoHideOnlyWhenFullScreen ) createAutoHideListener () ;
			
		}
		private function fClickPlayOrPause(e:Event) {
			if (pIsOnPause) {
				 play(); 
				 setPlayState ();
			} else {
				pause();
				setPauseState ();
			}
		}
		private function fClickOpenClose(e:Event) {
			if (pIsClose) {
				 openScroll ();
			} else {
				closeScroll ();
			}
			pIsClose=!pIsClose;
		}
		private function closeScroll () {			
				
			view.addEventListener("onScrollIsClose",fShowOpenButton);
			view.closeScrollFrame();
		}	
		private function openScroll () {			
					
			view.addEventListener("onScrollIsOpen",fShowCloseButton);
			view.openScrollFrame();
		}	
		private function fShowOpenButton (ex:EventX) {			
			view.closeScroll.visible=false;			
			view.openScroll.visible=true;
		}	
		private function fShowCloseButton (ex:EventX) {				
			view.closeScroll.visible=true;			
			view.openScroll.visible=false;	
		}	
		private function setPauseState () {			
			view.play.visible=true;			
			view.pause.visible=false;
			view.displayInvit(param.lang.play.label);
		}	
		private function setPlayState () {			
			view.play.visible=false;			
			view.pause.visible=true;
			view.displayInvit(param.lang.pause.label);
		}
		
		private function clear() {					
			//if (pLs!=null) pLs.remove();			
			if (pBl!=null) {
				pBl.removeEventListener("onLoadBatch",fOnLoadThumb);
				pBl=pBl.remove();
			}			
			for (var i:Number=0;i<model.imageList.length;i++) {
				var om:OneModel=model.imageList[i];
				om.remove();					
			}	
			view.scrollContainer.removeAllChild();
			if (pScrollMng!=null) pScrollMng.remove();
			//
			pIdle = false;
			model.currIndex = 0;
			if (clock!=null) clock=clock.remove();
			view.displayTitle();
			view.displayInvit();
		}
		
	}//End of Class Controler
}
