﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/
package net.flash_line.as3.diapo.fromFolder {	

	import net.flash_line.as3.util.contextHelp.custom.DiapoRightClic ;
	import net.flash_line.as3.util.common.SpriteX;
	import net.flash_line.as3.util.global.setGlobalDebug;
	import net.flash_line.as3.util.global.appInit;
	import net.flash_line.as3.util.mvc.AbstractMain;
	/**
	* Initial class of Diapo
	* <p>Creates MVC instances.<br/>
	* extends AbstractMain.</p>
	* @see net.flash_line.as3.diapo.fromFolder.Model
	* @see net.flash_line.as3.diapo.fromFolder.View
	* @see net.flash_line.as3.diapo.fromFolder.Controler
	* @see net.flash_line.as3.util.mvc.AbstractMain
	*/ 
	public class Main extends AbstractMain { 
		
		/**
		* Constructor
		* <p>launch create()</p>
		* @see net.flash_line.as3.util.mvc.AbstractMain#create()
		* @param	prt			The root sprite - generally the caller and instance creator
		* @param	version		The # of version which is displayed on mouse right clic
		* @param	stdFont		The standard font name - If stdFont!=null the font must exist and to be embed before
		*/
		public function Main (prt:SpriteX,version:String="1.0.0",stdFont:String="Verdana") {				
			super(prt,Model,View,Controler);
			// records instance 
			setClassInfo("Main",this);	
			//Init appli
			init(version,"FL Slides Show ",stdFont,12);
			// external Xml model filename
			setBaseUrl("baseUrl");
			setModelFilename ("modelUrl") ;			
			setProgressFilename(baseUrl+"asset/loading/preload.swf"); 
			create(false) ;
			setGlobalDebug( (model.receivedVar.debug.toLowerCase()=="true")  );	
			control.begin(pModelSrc,pProgressSrc);
		}
		/**
		* Model instance
		*/
		public function get model () :Model {
			return super._model ;
		}
		/**
		* Controler instance
		*/
		public function get control () :Controler {
			return super._control;
		}
		/**
		* View instance
		*/
		public function get view () :View {
			return super._view ;
		}
		override public function init (version:String,vName:String,font:String="Verdana",size:Number=12):void {
			// use only in subclass : if component(s) exist : setGlobalStyle(font,size);
			new DiapoRightClic(this,vName+" "+version);	
			appInit (pParent,font,size);
		}
	} //End of Class Main
}