﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.diapo.fromFolder {	 
	
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.io.Xdata;
	import net.flash_line.as3.util.xml.XmlParser;
	import net.flash_line.as3.util.mvc.AbstractModel;
	//
	import net.flash_line.as3.diapo.fromFolder.OneModel;
	/**
     * Dispatched when images xml flux is loaded.
	 * @eventType net.flash_line.as3.util.event.EventX.ON_LOAD_XML
	 * @see #dispatchEvt()
     */
    [Event( name="onLoadXml", type="net.flash_line.as3.util.event.EventX" )]
	//
	/**
	* Manage application's model.
	* Load standard model from xml file, load images model from xml flux, store vars and params.  
	* 
	*/
	public class Model extends AbstractModel { 
		private var pModelArray:ModelArray;
		private var pCurrIndex:Number;
		private var pCurrImg:OneModel;
		private var pPrevImg:OneModel;
		private var pFolderStk:ArrayX;
		
		
	/**
	* Constructor
	* @param	mn	Instance : Main
	*/
		public function Model (mn:Main) {		
			super(mn);
			setClassInfo("Model",this);	
			initFolderStack();
		}	
		/**
		* @return Main instance
		*/
		public function get main ():Main {
			return super._main;
		}
		
		public function get view ():View {
			return main.view ;
		}	
		/**
		* images' folder - relative to image root url
		*/	
		public function get folderStk ():ArrayX {
			return pFolderStk ;
		}
		
		
		/**
		* images array
		*/	
		public function get imageList ():ModelArray {
			return pModelArray ;
		}
		public function set currImg (om:OneModel) {
			pCurrImg=om ;
		}
		public function get currImg ():OneModel {
			return pCurrImg ;
		}
		public function set prevImg (om:OneModel) {
			pPrevImg=om ;
		}
		public function get prevImg ():OneModel {
			return pPrevImg ;
		}
		public function set currIndex (n:Number) {
			pCurrIndex=n ;
		}
		public function get currIndex ():Number {
			return numVal(pCurrIndex,-1) ;
		}
		//
		public function get progressBarMng ():String {
			return xmlFolder+param.progressBarMng.src;
		}
		//
		// gets of some xml params
		public function get mayBeClosed ():Boolean {
			return (param.scroll.mayBeClosed=="true" && view.openClose!=null);
		}		
		public function get autoHide ():Boolean {
			return boolVal(param.bar.autoHide.hide=="true",false) ;
		}
		public function get autoHideOnlyWhenFullScreen ():Boolean {
			return boolVal(param.bar.autoHide.onlyWhenFullScreen=="true",false) ;
		}
		public function get delayHide ():Number {
			return numVal(param.bar.autoHide.delay,10) ;
		}
		
		//
		//
		//
		public function loadLanguage () {
			var src:String=strVal(receivedVar.language,"xml/lang.xml");
			src=getFullPath(src);
			var xlp= new XmlParser(src);	
			xlp.addEventListener("onParseXml",fOnLoadLanguage);
			xlp.addEventListener("onErrorXml",fOnErrorLoadLanguage);
			xlp.loadXml();			
		}		
		
		public function loadImageModel () {		
			var fluxSrc:String=getFullPath(receivedVar.source);
			var sv:Object={folder:getFolderPath()};
			var io:Xdata=new Xdata();
			io.addEventListener("onLoadXml",fOnLoadImgXml);
			io.addEventListener("onErrorLoadXml",fOnErrorLoadImgXml);
			io.sendVarAndLoadXml(fluxSrc,sv);
		}		
		public function getFolderPath() {	
			var str:String="";
			for (var i:Number=0;i<pFolderStk.length;i++){
				str+=pFolderStk[i]
			}
			return str;
		}
		
		
		private function fOnLoadLanguage (e:EventX) {
			 tree.lang=e.srcVar.tree.lang;
			 dispatchEvt("onLoadLanguage");
		}
		private function fOnErrorLoadLanguage (e:EventX) {
			error("Language file not found !!");
		}
		private function fOnLoadImgXml (e:EventX) {
			 if (pModelArray!=null) pModelArray.remove();
			 pModelArray=new ModelArray();	
			 pModelArray.create(new XmlParser().parse(e.srcVar.xml).image.row,pFolderStk);
			dispatchEvt(EventX.ON_LOAD_XML,{xml:e.srcVar.xml});
		}
		private function fOnErrorLoadImgXml () {		
			error(tree.lang.error.imageXmlLoad.label) ;
		}
		private function initFolderStack () {
			pFolderStk=new ArrayX();
			var str:String=strVal(receivedVar.folder,"");			
			if (str!="") {
				if (str.substring(str.length-1,str.length)!="/") str+="/";
			}
			pFolderStk.push(str);
		}		
		
	}//End of Class Model
}//end of package
