﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.diapo.fromFolder {
	import net.flash_line.as3.diapo.fromFolder.graph.Thumb ;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	/**
	* Model class for one image 
	*/
	public class OneModel extends Super {
		private var pSrc				:String;		//
		private var pThumb				:String;		// 
		private var pType				:String;		// 
		private var pName				:String;		// 
		private var pTitle				:String;		// 
		private var pThumbSpx			:Thumb;			// 
		private var pImageSpx			:SpriteX;		//
		private var pIndex				:Number;
		/**
		* Constructor - Contains one image properties
		*/
		public function OneModel () {
			setClassInfo("OneModel",this);
		}

	
		/**
		* Image filename
		*/
		public function get src ():String {
			return pSrc;
		}
		/**
		* Image filename
		*/
		public function set src (str:String){
			pSrc=str;
		}
		/**
		* Thumb filename or "" - facultative in xml flux
		*/
		public function get thumb ():String {
			return pThumb;
		}
		/**
		* Thumb filename or "" - facultative in xml flux
		*/
		public function set thumb (str:String){
			pThumb=str;
		}
		/**
		* Type "folder" or "" for image
		*/
		public function get type ():String {
			return pType;
		}
		/**
		* Type "folder" or "" for image
		*/
		public function set type (str:String){
			pType=str;
		}
		/**
		* images's title - null if  type="folder"
		*/
		public function get title ():String {
			return pTitle;
		}
		/**
		* images's title - null if  type="folder"
		*/
		public function set title (str:String){
			pTitle=str;
		}
		/**
		* foldername - null if  type!="folder"
		*/
		public function get name ():String {
			return pName;
		}
		/**
		* foldername - null if  type!="folder"
		*/
		public function set name (str:String){
			pName=str;
		}
		//
		//
		/*
		* thumb sprite
		*/
		public function get thumbSpx ():Thumb{
			return pThumbSpx;
		}
		/*
		* thumb sprite
		*/
		public function set thumbSpx (spx:Thumb){
			pThumbSpx=spx;
		}
		/**
		* image sprite
		*/
		public function get imageSpx ():SpriteX{
			return pImageSpx;
		}
		/**
		* image sprite
		*/
		public function set imageSpx (spx:SpriteX){
			pImageSpx=spx;
		}
		/**
		* array index number of this image
		*/
		public function get index ():Number{
			return pIndex;
		}
		/**
		* array index number of this image
		*/
		public function set index (i:Number){
			pIndex=i;
		}
		
		
		

		/**
		* create one image model
		* @param	o	Object with one image's properties
		* @param	i	Index in Array container
		*/
		public function create (o:Object,i:Number) {
			src=o.src;
			type=o.type.toLowerCase();
			title=o.title;
			index=i;
			if (type=="folder") {
				name=o.name;
			} else {				
				thumb=strVal(o.thumb,"");
			}
			
			
		}
		public function remove () {
			pTitle=null;
			if (pThumbSpx!=null) pThumbSpx.remove();
			if (pImageSpx!=null) pImageSpx.remove();
			pSrc=null;
			pThumb=null;
			pType=null;
			pName=null;
			pIndex=null;
		}

		
	}//End of Class OneModel
}

