﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/
package net.flash_line.as3.diapo.fromFolder {	
	import flash.events.* ;
	import flash.display.*;
	import flash.text.*;
	//
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.motion.Pursuit ;
	import net.flash_line.as3.util.mvc.AbstractView;
	import net.flash_line.as3.util.graph.*;
	import net.flash_line.as3.util.motion.BasicTween;
	import net.flash_line.as3.util.ui.ButtonMng;
	import net.flash_line.as3.util.text.*;
	import net.flash_line.as3.diapo.fromFolder.graph.Thumb ;
	/**
	* View class / display methods
	*/	
	class View extends AbstractView  {
		private var pCurrImgSpx		:SpriteX;		// Current image sprite
		private var pPrevImgSpx		:SpriteX;
		private var pCurrImgSize	:Object;		// current image size 
		private var pPrevImgSize	:Object;		// previous image size 
		private var pCloseStk		:ArrayX;		// Stack used by open/close tweens
		private var pPursuitStk		:ArrayX;		// Stack used by open/close tweens
		/**
		* Constructor
		* @param	mn	Main instance
		* @param	prt	Root Sprite container
		*/
		public function View (mn:Main,prt:SpriteX) {		
			super(mn,prt);
			stack=new ArrayX();
			pCloseStk=new ArrayX();
			pPursuitStk=new ArrayX();
			setClassInfo("View",this);
		}
		public function get main() :Main  {
			return super._main;
		}			
		public function get model() : Model  {
			return main.model;
		}
		
		// include main buttons sprites getters
		include "viewGet.inc.as" ;
		//
		//
		public function get isClose () : Boolean {	
			return (main.control.isClose && model.mayBeClosed) ;
		}
		/**
		* Container of first then all images
		*/
		public function get target () : SpriteX {	
			return parentCtnr.getSpx("target");
		}
		public function get firstImage () : SpriteX {	
			return target.getSpx("firstImage");
		}

		/**
		* A property true if fullScreen is on
		* @return true if fullScreen is on
		*/
		public function get fullScreenIsOn () : Boolean {	
			return (parentCtnr.stage.displayState==StageDisplayState.FULL_SCREEN); 
		}		
		// scroll margin
		public function get scrollMrg () : Number {	
			return N(param.scroll.margin);
		}
		// title text field
		public function get titleTf () : TextFieldX {	
			return bar.getTfx("title") ;
		}
		// invit Text field
		public function get invitTf () : TextFieldX {	
			return bar.getTfx("invit") ;
		}		
		// invit normal width
		public function get invitWidth () : Number {	
			return verti01.x-(playPause.x+playPause.width);
		}		
		// image margin
		public function get mrg () : Number {	
			return N(param.image.margin);
		}
		/**
		* Init swap type buttons
		* @param	playIsOn		true if play button must begin with state "on" - play
		* @param	fullScreenIsOn	true if fullScreen button must begin with state "on" - fullscreen
		*/
		public function init(playIsOn:Boolean,fullScreenIsOn:Boolean,pinsIsOn:Boolean=false) {
			pCurrImgSpx=firstImage;
			createTextField();
			initButton();
			initOneSwapButton(playIsOn,play,playOut,playOver,playDown,pause,pauseOut,pauseOver,pauseDown);
			initOneSwapButton(fullScreenIsOn,fullScreenOn,fullScreenOnOut,fullScreenOnOver,fullScreenOnDown,fullScreenOff,fullScreenOffOut,fullScreenOffOver,fullScreenOffDown);	
			initOneSwapButton(pinsIsOn,pinsOn,pinsOnOut,pinsOnOver,pinsOnDown,pinsOff,pinsOffOut,pinsOffOver,pinsOffDown);	
			createFrameLine();			
			firstImage.alpha=N(param.start.alpha);
		}
		
		public function getCentralArea() :SpriteX {	
			var spx:SpriteX=parentCtnr.getSpx("centralArea");
			if (spx == null) {
				spx=new RectFill(parentCtnr,0,0,100,100,0x0,0,"centralArea");				
			}			
			spx.x=firstImage.x;spx.y=firstImage.y;
			spx.width=firstImage.width;spx.height=firstImage.height;	
			return spx;
		}
		
		/**
		* Create inner SpriteWithMask with container et msk properties
		* @see net.flash_line.as3.util.graph.SpriteWithMask#msk
		* @see net.flash_line.as3.util.graph.SpriteWithMask#container
		* 
		*/
		public function createScrollBox() {	
			new SpriteWithMask(scroll,N(param.scroll.mask.x),N(param.scroll.mask.y),N(param.scroll.mask.width),N(param.scroll.mask.height),"box");
		}
		public function createBgInScrollContainer() {
			var spx:SpriteX=scrollContainer;
			var rf:RectFill=new RectFill(spx,0,0,spx.width,spx.height,0x0,0,"bg");
			rf.setDepthAt (0);
		}
		public function createTextField() {
			// Play/pause invit
			var vx:Number=N(param.bar.invit.x);var vy:Number=N(param.bar.invit.y);
			var h:Number=bar.height*.8;var w:Number=invitWidth;
			var tc:Number=N(param.bar.invit.color);var size:Number=N(param.bar.invit.size)
			new TextFieldX(bar,vx,vy,w,h,tc,getFont(),size,false,true,null,"invit"); // {autoSize:TextFieldAutoSize.LEFT}
			// title
			vx=N(param.bar.title.x);vy=N(param.bar.title.y);
			tc=N(param.bar.title.color);size=N(param.bar.title.size) ; w=firstImage.width-vx;
			new TextFieldX(bar,vx,vy,w,h,tc,getFont(),size,false,true,null,"title"); //{autoSize:TextFieldAutoSize.LEFT}
		}
		public function displayInvit(txt:String="") {
			invitTf.setText(txt);
		}
		public function displayTitle(folderLab:String="",folderVal:String="",titleLab:String="",titleVal:String="") {
			var txt:String=folderLab+folderVal+titleLab+titleVal;
			titleTf.setText(txt);
			if (txt=="") return ;
			var s:Number=folderLab.length;
			var e:Number=s+folderVal.length;
			var size:Number=N(param.bar.title.folderSize);
			titleTf.setFormat({bold:true,size:size},s,e);
			s=folderLab.length+folderVal.length+titleLab.length;
			e=s+titleVal.length;
			size=N(param.bar.title.titleSize);
			titleTf.setFormat({bold:true,size:size},s,e);
			
		}
		public function showSkin() {
			parentCtnr.showAllChild();
		}
		public function hideSkin() {
			parentCtnr.hideAllChild();
		}
		public function showHideScroll() {
			if (scrollContainer.height<scrollMsk.height) {
				//scrollFrame.alpha=.5 ;
				scrollDownBar.visible=false ;
				scrollUpBar.visible=false ;
			} else {
				//scrollFrame.alpha=1 ;
				scrollDownBar.visible=true ;
				scrollUpBar.visible=true ;
			}
		}
		public function closeScrollFrame() {
			var d:Number=N(param.application.tweenDuration);
			var diff:Number=openClose.x-scroll.x;
			pCloseStk.push(new BasicTween(scroll,"x",stage.stageWidth+mrg,d));
			pCloseStk.push(new BasicTween(openClose,"x",stage.stageWidth-mrg-diff,d));
			pCloseStk.push(new Delay2(d*.5));	
			pCloseStk.last.addEventListener(EventX.ON_DELAY,closeScrollFrame2);				
		}
		public function closeScrollFrame2(ex:EventX) {
			var d:Number=N(param.application.tweenDuration);
			pCloseStk.push(new BasicTween(firstImage,"width",stage.stageWidth-mrg,d));
			pCloseStk.push(new BasicTween(barBg,"width",stage.stageWidth-mrg,d));
			var rightX:Number=stage.stageWidth-(3*mrg);  
			if (next!=null) pCloseStk.push(new BasicTween(next,"x",rightX,d));			
			dispatchEvt("onScrollIsClose");
		}
		public function openScrollFrame() {			
			var d:Number=N(param.application.tweenDuration);
			pCloseStk.push(new BasicTween(firstImage,"width",stage.stageWidth-mrg-scroll.width,d));	
			pCloseStk.push(new BasicTween(barBg,"width",stage.stageWidth-mrg-scroll.width,d));
			var rightX:Number=stage.stageWidth-scroll.width-(3*mrg);  
			if (next!=null) pCloseStk.push(new BasicTween(next,"x",rightX,d));	
			pCloseStk.push(new Delay2(d*.5));
			pCloseStk.last.addEventListener(EventX.ON_DELAY,openScrollFrame2);			
		}
		public function openScrollFrame2(ex:EventX) {
			var d:Number=N(param.application.tweenDuration);
			var e:Number=stage.stageWidth-scroll.width
			pCloseStk.push(new BasicTween(scroll,"x",e,d));
			pCloseStk.push(new BasicTween(openClose,"x",e-openClose.width*.5,d));
			pCloseStk.push(new Delay2(d));
			pCloseStk.last.addEventListener(EventX.ON_DELAY,openScrollFrame3);		
		}
		public function openScrollFrame3(ex:EventX) {
			dispatchEvt("onScrollIsOpen");
		}
		public function hideBottomBar () {
			var d:Number=N(param.application.tweenDuration);
			pCloseStk.push(new BasicTween(bar,"y",stage.stageHeight+mrg,d));			
			pCloseStk.push(new BasicTween(firstImage,"height",stage.stageHeight-1,d));
			pCloseStk.push(new Delay2(d));	
			pCloseStk.last.addEventListener(EventX.ON_DELAY,hideBottomBar2);
			if (hiddenBar==null) new RectFill(parentCtnr,0,stage.stageHeight+mrg,10,10,0,0,"hiddenBar");
		}
		public function hideBottomBar2 (ex:EventX) {
			var vy:Number=stage.stageHeight-bar.height;
			hiddenBar.y=vy;hiddenBar.width=bar.width;hiddenBar.height=bar.height;
			dispatchEvt("onBarIsHidden");		
		}
		public function restoreBottomBar () {
			hiddenBar.y=stage.stageHeight+mrg;
			var d:Number=N(param.application.tweenDuration);
			pCloseStk.push(new BasicTween(bar,"y",stage.stageHeight-bar.height,d));			
			pCloseStk.push(new BasicTween(firstImage,"height",stage.stageHeight-bar.height-mrg,d));
			pCloseStk.push(new Delay2(d));	
			pCloseStk.last.addEventListener(EventX.ON_DELAY,restoreBottomBar2);
		}
		public function restoreBottomBar2 (ex:EventX) {
			dispatchEvt("onBarIsRestored");			
		}
		public function getNewEmptyThumb(vx:Number,vy:Number,w:Number,h:Number) :Thumb {
			return new Thumb(scrollContainer,vx,vy,w,h,param);
		}
		
		/**
		* Set fullscreen mode - must be called in a user event listener only.
		*/
		public function setFullScreen ()  {	
			parentCtnr.stage.displayState=StageDisplayState.FULL_SCREEN;
		}
		/**
		* Set normal screen mode
		*/
		public function setNormalScreen () {
			parentCtnr.stage.displayState=StageDisplayState.NORMAL;
		}
				
		public function displayImage(spx:SpriteX) {	
			pPrevImgSpx=pCurrImgSpx ;
			pCurrImgSpx=spx ;
			pCurrImgSize={width:pCurrImgSpx.width,height:pCurrImgSpx.height};
			pPrevImgSize={width:pPrevImgSpx.width,height:pPrevImgSpx.height};
			//
			resizeImage(pCurrImgSpx,pCurrImgSize);
			//
			pCurrImgSpx.alpha = 0;
			//
			var d:Number=N(param.application.tweenDuration);
			if (pPrevImgSpx!=firstImage) stack.push(new BasicTween(pPrevImgSpx,"alpha",0,d));
			stack.push(new BasicTween(pCurrImgSpx,"alpha",1,d));
			new Delay2(d).addEventListener(EventX.ON_DELAY,clearPreviousImage);
			//
			
		}
		public function lightOnThumb(spx:Thumb) {	
			if (spx != null) {
				if (spx.image != null)  spx.image.removeAllFilter();
				if (spx.back != null ) spx.back.setOneColor(N(param.scroll.thumb.background.selectedColor), 1);
			}
			
		}
		public function lightOffThumb(spx:Thumb) {	
			spx.image.changeSaturation(.60);
			if (spx.back!=null ) spx.back.restoreColor();
			if (spx.over!=null ) spx.over.visible=false ; 
		}
		public function locateAndResize() {	
			removePursuit();
			// target image
			target.x=0;
			target.y=0;		
			//scroll
			scroll.x=stage.stageWidth-scroll.width;	
			scroll.y=0;			
			// bar
			bar.y=stage.stageHeight-bar.height;
			bar.x=0;
			// images
			firstImage.width=scroll.x-mrg;
			firstImage.height=bar.y-mrg ;	
			getCentralArea();
			if (pCurrImgSpx!=null) resizeImage(pCurrImgSpx,pCurrImgSize); 
			if (pPrevImgSpx!=null) resizeImage(pPrevImgSpx,pPrevImgSize);			
			// bar bg
			barBg.width=firstImage.width;
			barBg.x=3;
			// scroll elements
			scrollFrame.height=stage.stageHeight; 			
			scrollDownBar.y=scrollFrame.height-scrollDownBar.height;
			scrollBox.mskHeight=stage.stageHeight-scrollDownBar.height*2-scrollMrg;
			// open close scroll
			if (model.mayBeClosed) {
				openClose.x=scroll.x-openClose.width*.5;
				openClose.y=(scrollFrame.height-openClose.height)*.5;					
				pCloseStk.clear();
			}			
			if (isClose) {				
				var diff:Number=openClose.x-scroll.x;
				scroll.x=stage.stageWidth+mrg;
				openClose.x=stage.stageWidth-mrg-diff;
				firstImage.width=stage.stageWidth-mrg;
				barBg.width=stage.stageWidth-mrg;
			}
			// prev/next and pins button
			var rightX:Number=barBg.x+barBg.width; var oRightX=rightX; var mrgCoef:Number=.35;
			if (next!=null) { next.x=Math.round(rightX-next.width-mrg) ; rightX=next.x ; }
			if (prev!=null) { prev.x=Math.round(rightX-prev.width-mrg*mrgCoef) ; rightX=prev.x ; }
			if (model.autoHide) {
				if (verti03!=null) { verti03.x=Math.round(rightX-mrg*mrgCoef) ; rightX=verti03.x ; }
				if (pins!=null) { pins.x=Math.round(rightX-pins.width-mrg*mrgCoef) ; rightX=pins.x ; }
			} 
			if (verti04!=null) { verti04.x=Math.round(rightX-mrg*mrgCoef-1) ; rightX=verti04.x ; }			
			var rightIsHidden:Boolean=!showHideRight(rightX);
			if (rightIsHidden) rightX=oRightX;
			rightX-=Math.round(mrg*mrgCoef);
			//title			
			titleTf.width=rightX-titleTf.x;
			invitTf.width=Math.min(barBg.width-invitTf.x,invitWidth);
			showHide(verti01);showHide(verti02);
			showHide(fullScreen);showHide(playPause);
			initPursuit();
			
		}
		// private
		private function createFrameLine() {
			var spx:SpriteX=scrollFrame.getSpx("outer");
			if (spx!=null) spx.remove();
			var spx:SpriteX=scrollFrame.getSpx("inner");
			if (spx!=null) spx.remove();
			var w:Number=scrollFrame.width-1;var h:Number=scrollFrame.height;
			var c:Number=N(param.scroll.frameLine.outer.color);var a:Number=N(param.scroll.frameLine.outer.alpha);
			new RoundRectLine(scrollFrame,0,0,w,h,c,a,0,"outer",1);
			w-=2;h-=2;
			c=N(param.scroll.frameLine.inner.color);a=N(param.scroll.frameLine.inner.alpha);
			new RoundRectLine(scrollFrame,1,1,w,h,c,a,0,"inner",1);
		}
		
		private function showHide(spx:SpriteX) {
			spx.visible=(barBg.width>spx.x+spx.width);
		}
		private function showHideRight(vx:Number) {
			if (vx<(fullScreen.x+200)) {
				hideRightElement();
				return false;
			} else {
				showRightElement();
				return true ;
			}
		}
		private function hideRightElement() {
			if (next!=null) next.visible=false ;
			if (prev!=null) prev.visible=false ;
			if (verti03!=null) verti03.visible=false ;
			if (pins!=null) pins.visible=false ;
			if (verti04!=null) verti04.visible=false ;
		}
		private function showRightElement() {
			if (next!=null) next.visible=true ;
			if (prev!=null) prev.visible=true ;
			if (model.autoHide) {
				if (verti03!=null) verti03.visible=true ;
				if (pins!=null) pins.visible=true ;
			}			
			if (verti04!=null) verti04.visible=true ;
		}
		private function resizeImage(img:SpriteX,o:Object) {	
			if (img!=firstImage) {
				var ww:Number = firstImage.width ;
				var hh:Number = firstImage.height ;	
				img.width = Math.min(o.width ,ww-mrg) ;
				img.scaleY= img.scaleX;
				img.height = Math.min(img.height,hh-mrg) ;
				img.scaleX= img.scaleY ;	
				img.x = (ww  - img.width ) / 2 ;
				img.y = (hh  - img.height ) / 2 ;
			}
		}		
		
		private function clearPreviousImage(ex:EventX) {
			stack.clear();	
			dispatchEvt(EventX.ON_IMAGE_DISPLAY);
			if (pPrevImgSpx!=firstImage) pPrevImgSpx.remove();
		}
		// button init functions
		private function initButton () {
			initOneButton(playPause,playOut,playOver,playDown,pauseOut,pauseOver,pauseDown);
			initOneButton(fullScreen,fullScreenOnOut,fullScreenOnOver,fullScreenOnDown,fullScreenOffOut,fullScreenOffOver,fullScreenOffDown);			
			initOneButton(pins,pinsOnOut,pinsOnOver,pinsOnDown,pinsOffOut,pinsOffOver,pinsOffDown);			
			initOneScrollButton(scrollUpButton,scrollUpOut,scrollUpOver,scrollUpPress);			
			initOneScrollButton(scrollDownButton,scrollDownOut,scrollDownOver,scrollDownPress);	
			// next/prev
			initOneStandardButton(prev,prevOut,prevOver,prevOver);
			initOneStandardButton(next,nextOut,nextOver,nextOver);
		}
		private function initOneButton (ctnr:SpriteX,onOut:SpriteX,onOver:SpriteX,onDown:SpriteX,offOut:SpriteX,offOver:SpriteX,offDown:SpriteX) {
			ctnr.hideAllChild();
			var w=ctnr.width;var h=ctnr.height;
			var sp:SpriteX=new RectFill(ctnr,0,0,w,h,0,0,"click");
			new ButtonMng (sp,onOut,onOver,onDown);
			new ButtonMng (sp,offOut,offOver,offDown);
			
		}		
		private function initOneStandardButton (ctnr:SpriteX,onOut:SpriteX,onOver:SpriteX,onDown:SpriteX) {
			ctnr.hideAllChild();
			var w=ctnr.width;var h=ctnr.height;
			var sp:SpriteX=new RectFill(ctnr,0,0,w,h,0,0,"click");
			new ButtonMng (sp,onOut,onOver,onDown);
			onOut.visible=true;
		}		
		private function initOneScrollButton (ctnr:SpriteX,onOut:SpriteX,onOver:SpriteX,onDown:SpriteX) {
			ctnr.hideAllChild();
			var w=ctnr.width;var h=ctnr.height;
			var sp:SpriteX=new RectFill(ctnr,-scrollUpBar.width*.45,0,w+scrollUpBar.width*.90,h,0,0,"click");
			new ButtonMng (sp,onOut,onOver,onDown);
			onOut.visible=true;
		}		
		private function initOneSwapButton (isOn:Boolean,on:SpriteX,onOut:SpriteX,onOver:SpriteX,onDown:SpriteX,off:SpriteX,offOut:SpriteX,offOver:SpriteX,offDown:SpriteX) {
			if (isOn) {				
				off.visible=true;
				offOut.visible=true;
				offOver.visible=false;
				offDown.visible=false;
				on.visible=false;
				onOut.visible=true;
				onOver.visible=false;
				onDown.visible=false ;
			} else {
				off.visible=false;
				offOut.visible=true;
				offOver.visible=false;
				offDown.visible=false;
				on.visible=true;
				onOut.visible=true;
				onOver.visible=false;		
				onDown.visible=false ;
			}
		}
		private function removePursuit () {
			pPursuitStk.clear();
		}		
		private function initPursuit () {
			if (next==null) return;
			var brother:SpriteX=next;
			if (prev!=null) { pPursuitStk.push(new Pursuit(prev,brother)); brother=prev}
			if (model.autoHide) {
				if (verti03!=null) { pPursuitStk.push(new Pursuit(verti03,brother)); brother=verti03}
				if (pins!=null) { pPursuitStk.push(new Pursuit(pins,brother)); brother=pins}
			}			
			if (verti04!=null) pPursuitStk.push(new Pursuit(verti04,brother)); 
		}		
		
	}//End of Class View
}
