﻿/**
* Diapo under GPL
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/
package net.flash_line.as3.diapo.fromFolder.graph {	 
	import flash.display.DisplayObjectContainer ;
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.graph.* ;
	import net.flash_line.as3.util.text.* ;
	
	/**
	* One thumb in scroll box
	*/ 
	public class  Thumb  extends SpriteX {			
			/**
			* Input width
			*/
			protected		var pW			: Number		;	// 
			/**
			* Input height
			*/
			protected		var pH			: Number		; 	// input height
			
			
		/**
		* constructor : create empty thumb
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		*/
		public function Thumb	 	  ( ctnr:DisplayObjectContainer,vx:Number,vy:Number,w:Number,h:Number,param:Object) {		
			super (ctnr,vx,vy,1) 			
			setClassInfo("Thumb",this);			
			pW			= w			;
			pH			= h			;
			create(param);
		}
		/*
		* 
		*/
		public function get back ():SpriteX {
			return this.getSpx("back");
		}
		public function get image ():SpriteX {
			return this.getSpx("image");
		}
		public function get tf ():TextFieldX {
			return this.getTfx ("tf");
		}
		public function get layer ():SpriteX {
			return this.getSpx("layer");
		}
		public function get over ():SpriteX {
			return this.getSpx("over");
		}
		private function create(param:Object) {
			new RectFill(this,0,0,pW,pH,N(param.scroll.thumb.background.color),1,"back");
			new SpriteX(this,N(param.scroll.thumb.image.margin),N(param.scroll.thumb.image.margin),1,"image");
			new TextFieldX(this,0,N(param.scroll.thumb.textField.y),pW,N(param.scroll.thumb.textField.height),N(param.scroll.thumb.textField.textColor),getFont(),N(param.scroll.thumb.textField.size),false,true,null,"tf");
			new RectFill(this,0,0,pW,pH,N(param.scroll.thumb.layer.color),N(param.scroll.thumb.layer.alpha),"layer");
			new RoundRectLine(this,0,0,pW,pH,N(param.scroll.thumb.over.color),N(param.scroll.thumb.over.alpha),1,"over",1);
			
		}
		
	}
}