﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/  
package net.flash_line.as3.util.bitmap {	 
	import flash.geom.*
	import flash.display.* 
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.event.EventX ;
	import net.flash_line.as3.util.ui.ErrorFrame ;
	/**
	* create a new Bitmap from a Rectangle of a source Bitmap .
	*/
	public class  Bmp  extends Bitmap implements ISuper {			
		var pBmpx:Object;	
		var pCtnr:DisplayObjectContainer;	
		var pX:Number;	
		var pY:Number;	
		include "../common/isuper.inc.as";	
		/**
		* constructor
		* @param bmpx an Object with properties :
		* 		 .bitmap source Bitmap instance
		* 		 .bitmapData source BitmapData instance
		* 		 .rectangle source Rectangle instance
		*/
		public function Bmp	 	  (ctnr:DisplayObjectContainer,bmpx:Object,vx:Number=0,vy:Number=0) {		
			pBmpx=bmpx;pCtnr=ctnr;
			super(new BitmapData(pBmpx.rectangle.width,pBmpx.rectangle.height,true));
			setClassInfo("Bmp",this);			
			pX=vx;
			pY=vy;
			refreshPos();
		}
		/**
		* copy source bitmap rectangle in this Bitmap
		* 
		*/
		public function copyPixelsX() {
			this.bitmapData.copyPixels(pBmpx.bitmapData,pBmpx.rectangle,new Point(0,0),null,null,true);		
			pCtnr.addChild(this);
			refreshPos();
		}
		/**
		* do a vertical symetrie
		*/
		public function doHeightSym() {
			var mtx:Matrix = new Matrix();        
			mtx.d =-1;
			var currMtx:Matrix = transform.matrix;
			currMtx.concat(mtx);
			transform.matrix =currMtx;
			refreshPos();
		}
		public function copyChannelX(src:Object,from:Number=1,to:Number=8) {
			bitmapData.copyChannel(src.bitmapData,src.rectangle,new Point(0,0),from,to);
		}
		public function refreshPos() {
			x=pX;
			y=pY;			
		}
		public function remove() {
			this.bitmapData.dispose();	
			if (parent!=null) parent.removeChild(this);
		}
		
	}
}