﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.common {
	import net.flash_line.as3.util.ui.ErrorFrame ;
	/**
	* Basic classes Interface.
	* <p>A class which can't extend Super or SpriteX
	*  implements ISuper and so has the same basic methods of them</p>
	* <p>See the include file <b>isuper.inc.as</b> in same folder</p>
	* @see SpriteX
	* @see Super
	*/ 
	public interface ISuper {		
	    /**
		* set instance class info
		* @param	cn Classname
		* @param	inst Instance
		*/		
		function setClassInfo(cn:String,inst:Object) ;
		/**
		* display several debug messages in a unique alert window.
		* @param msg message string
		*/	
		function alert (msg:String) ;
		/**
		* display an error message
		* @param msg message string
		*/				
		function error (msg:String,autoClose:Boolean=true):ErrorFrame;
		/**
		* dispatch events with parameters
		* @param	msg
		* @param	o
		*/
		function dispatchEvt (msg:String,o:Object=null) ;
	}
}
