﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.common {	
	import net.flash_line.as3.util.global.*
	/**
	* Math method
	* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
	* @link http://www.flash-line.net
	*/ 
	public class MathX  { 
		/**
		* used to encrypt a number
		* @private
		*/
		static public var CODE_F:Number=7;
		/**
		* used to encrypt a number
		* @private
		*/
		static public var CODE_E:Number=9;
		/**
		* used to encrypt a number
		* @private
		*/
		static public var CODE_D:Number=2;
		/**
		* used to encrypt a number
		* @private
		*/
		static public var CODE_C:Number=3;
		/**
		* used to encrypt a number
		* @private
		*/
		static public var CODE_B:Number=5;
		
		/**
		* Compute the root Nth of a number
		* @param	n the number we look for its root
		* @param	N the level of root - by default N=3 : We look for the cubic root 
		* @param 	p Precision - by default : 2 digits after coma
		* @return   the root Nth of n  
		*/
		static public function rootNOf (n : Number,N:Number=3,p:Number=2) : Number {
			if (p<1) p=1;p=Math.round(p);
			if (N<1) N=1;N=Math.round(N);
			return Math.round(Math.pow(n,1/N)*Math.pow(10,p))/Math.pow(10,p);
		}
		/**
		* Build an Object with properties :
		* <p>
		* <table class=innertable>
		* <tr><th>Property</th><th>Value</th></tr>
		* <tr><td>minute</td><td>minute value</td></tr>
		* <tr><td>sec</td><td>second value</td></tr>
		* <tr><td>s100</td><td>second 100th value</td></tr>
		* <tr><td>str</td><td>The String "mm:ss:cc"</td></tr>
		* </table>	
		* </p>
		* @param	n a Number of 100th of second
		* @return an Object 
		*/
		static public function getFormatedTime (n : Number) : Object {
				var s100:Number=Math.round((n*100)%100); 
				n=Math.floor(n);
				var min:Number=Math.floor(n/60);
				var sec:Number=n%60;	
				var str:String;
				str=(min+100).toString().substring(1,3);
				str+=":";
				str+=(sec+100).toString().substring(1,3);
				str+=":";
				str+=(s100+100).toString().substring(1,3);
				return {min:min,sec:sec,s100:s100,str:str} ;
		}
		/**
		* Put each digit of a number of 4 digits as an element of Array
		* @param	n a Number 
		* @return	:
		* <p>
		* <table class=innertable>
		* <tr><th>Array index</th><th>Value</th></tr>
		* <tr><td>0</td><td>the original number</td></tr>
		* <tr><td>1</td><td>1st digit</td></tr>
		* <tr><td>2</td><td>2nd digidvalue</td></tr>
		* <tr><td>3</td><td>3rd digit</td></tr>
		* <tr><td>4</td><td>4th digit</td></tr>
		* </table>	
		* </p> 
		*/
		static public function num2Arr(n:Number):Array {
			var n=Number(n);
			var n1=Math.floor (n/1000);
			var m=n%1000;
			var n2=Math.floor (m/100);
			m=m%100;
			var n3=Math.floor (m/10);
			m=m%10;
			var n4=Math.floor (m);
			var arr = new Array(n,n1,n2,n3,n4);
			return arr;
		}
		/**
		* Encrypt a number
		* <p>If keys are null the methods take some static codes.</p>
		* @param	n		The number to be encrypted
		* @param	vbf		1st key
		* @param	vbe		2nd key
		* @param	vbd		3rd key
		* @param	vbc		4th key
		* @param	vbb		5th key
		* @return Encrypted Number
		*/
		static public function num2Crypt(n:Number,vbf:*=null,vbe:*=null,vbd:*=null,vbc:*=null,vbb:*=null):Number {
			var nsrc=Number(n);
			if (vbf==null) vbf=CODE_F;// sample 7;
			if (vbe==null) vbe=CODE_E;// sample 9;
			if (vbd==null) vbd=CODE_D;// sample 2;
			if (vbc==null) vbc=CODE_C;// sample 3
			if (vbb==null) vbb=CODE_B;// sample 5
			var ca=vbb*vbc*vbd*vbe*vbf;
			var cb=    vbc*vbd*vbe*vbf;
			var cc=        vbd*vbe*vbf;
			var cd=            vbe*vbf;
			var ce=               vbf;
			var a=Math.floor (nsrc/ca) ;
			var mb=nsrc%ca;
			var b=Math.floor (mb/cb) ;
			var mc=mb%cb;
			var c=Math.floor (mc/cc) ;
			var md=mc%cc;
			var d=Math.floor (md/cd) ;
			var me=md%cd;
			var e=Math.floor (me/ce) ;
			var mf=me%ce;
			var f=Math.floor (mf) ;
			var ncryp=a*100000+b*10000+c*1000+d*100+e*10+f;	
			return  ncryp;
		}
		
	}
}