		 /**
		 *  the classname of instance * 
		 * @private 
		 */		 
		var pClassName:String ;
		/**
		 *  if used pParent is the root parent sprite of the application.
		 * @private
		 */
		 protected var pParent			 : SpriteX		 ;
		/**
		 *  used to store last listener
		 * @private
		 */
		 protected var pLstFunction			 : Function		 ;
		/**
		* @private
		 *  standard stack
		 */
		 protected var pStack			 : ArrayX		 ;
		 //
		 //
		 /**
		* the root parent of the application if any or null
		* @param sp the root parent of the application
		*/	
		public function get rootParent (): SpriteX {
			return pParent;
		}
		/**
		* The standard stack
		* @return 
		*/		
		public function get stack (): ArrayX {
			return pStack;
		}
		/**
		* A standard stack
		* @param s an ArrayX
		* @see #ArrayX
		*/	
		public function set stack (s: ArrayX ){
			pStack=s;
		}
		/**
		* The classname
		*/		
		public function get className (): String {
			return pClassName;
		}
		/**
		* The classname
		*/			
		public function set className (s: String ){
			pClassName=s;
		}
		/**
		* the root parent of the application if any or null
		* @param sp the root parent of the application
		*/		
		public function set rootParent (sp:SpriteX) {
			pParent=sp;
		}
		//
		//
		/**
		* Push instance of this Class in the static public Instance class
		* @param	cn Classname
		* @param	inst Instance
		*/		
		public function setClassInfo(cn:String,inst:Object) {	
			className=cn;
			Instance.push(inst);
		}
		/**
		* dispatchEvt() dispatch events with a net.flash_line.as3.util.event.EventX parameter
		* <p>EventX has a property srcVar which may contains diverse dynamic properties to transfert to the listeners</p>		
		* <p>All net.flash_line.as3 events have the same type which is EventX</p>
		* <p>EventX extends flash.events.Event and all event source extends flash.events.EventDispatcher</p>
		* <p>dispatchEvt() use EventDispatcher.dispatchEvent(new EventX(evtName))</p>
		* <p>It's of course possible to do not use dispathEvt() for new source event classes</p>
		* <p>but using dispatchEvt() is less heavy than original AS3 system.</p>
		* <p>When using dispatchEvt() it isn't necessary to add event name constant</p>
		* <p>in EventX except when one want to have nice comments in asdoc ;)</p>
		* @see net.flash_line.as3.util.event.EventX#srcVar		
		* @see net.flash_line.as3.util.event.EventX		
		* @param	evtName A string which is event name
		* @param	o Object with properties -parameters- which will be assigned to EventX.srcVar 
		*/
		public function dispatchEvt (evtName:String,o:Object=null) {	
			var ex:EventX=new EventX(evtName);
			ex.srcVar=o;
			dispatchEvent(ex);			
		}				
		/**
		* display alert messages in one unique alert window
		* @param msg message string
		* @see net.flash_line.as3.util.common.AlertWin
		*/		
		public function alert (msg:String) {
			// by default debug will be equal to true.
			var debug:Boolean = boolVal(getGlobalVar().debug, true);
			if (debug) {
				if (msg != null) AlertWin.display(msg);
			}
		}
		/**
		* display an error message
		* @param msg message string
		*/		
		
		public function error (msg:String,autoClose:Boolean=true) :ErrorFrame {
			if (msg!=null) {				
				if (boolVal(Var.debug,true)==false ) return null ;				
				var ef:ErrorFrame=new ErrorFrame (Var.parent,msg,300,200,autoClose) ;				
			}
			return ef;
		}