﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.contextHelp {
	import flash.display.Sprite;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import net.flash_line.as3.util.common.SpriteX;
	import flash.events.* ;
	/**
	* Manage right clic 
	*/
	public class RightClic { 
		private var  pCmi		: ContextMenuItem ; 	// id of the ContextMenuItem Flash Object	
		private var  pCm		: ContextMenu ; 	//
		/**
		* Constructor
		* @param	mc	The sprite where user will do right clic
		* @param	arr	Array of Object with contents of the right clic frame.
		* <p>Example:</br>
		* new RightClic(mc,[</br>
		*							{caption:appli,enabled:false},</br>
		*							{caption:"Label A",handler:functionA} ,</br>
		*							{caption:"Label B",handler:functionB}</br>
		*						]</br>
		*					);</br>
		* </p>
		*/
		public function RightClic(mc:Sprite,arr:Array) {
			pCm = new ContextMenu();
			pCm.hideBuiltInItems();
			if (arr!=null) addContent(arr);	
			mc.contextMenu = pCm ;
		}
		/**
		* Add content , event listener and return the ContextMenuItem
		* @param	arr Array with contents of the right clic frame
		* @return 
		*/
		public function addContent(arr:Array): ContextMenuItem {		
			for (var i:Number=0;i<arr.length;i++) {
				var o:Object=arr[i];
				if (o.caption==null ) return null ;
				if (o.handler==null) o.handler=function(){};
				if (o.enabled==null) o.enabled=true;
				if (o.separatorBefore==null) o.separatorBefore=false ;
				if (o.visible==null) o.visible=true ;				
				pCmi = new ContextMenuItem(o.caption,o.separatorBefore, o.enabled,o.visible) ;
				pCmi.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,o.handler);
				pCm.customItems.push(pCmi);				
				/**/
			}
			return pCmi;
		}
		
		
		
	}; 
}