﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.event {
	import flash.events.* ;
	import flash.display.* ;
	import net.flash_line.as3.util.common.Super ;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import fl.transitions.TweenEvent ;
	/**
     * Dispatched at the end of given period.
	 * @eventType net.flash_line.as3.util.event.EventX.ON_DELAY
	 * @see #dispatchEvt()
     */
    [Event( name="onDelay", type="net.flash_line.as3.util.event.EventX" )]
	/**
	* send an "onDelay" event after n seconds
	* <p><span style="color:#ff0000">deprecated</span> use now Delay2 </p>
	*/ 
	public class Delay extends Super {
		/**
		* @private
		*/
		var pTween:Tween;
		//
		/**
		* constructor
		* @param	d Delay in second before onDelay event
		*/
		public function Delay(d) {
			setClassInfo("Delay",this);
			var mc:MovieClip=new MovieClip();	
			pTween=new Tween(mc,"_alpha",Regular.easeInOut,100,0,d,true);
			pTween.addEventListener(TweenEvent.MOTION_FINISH,onDelay);				
		}		
		/**
		* remove listener
		* @return null
		*/
		public function remove() : * {			
			pTween.removeEventListener(TweenEvent.MOTION_FINISH,onDelay);
			return null;
		}
		/**
		* listen TweenEvent.MOTION_FINISH
		* @param	e Native event object
		* @dispatch "onDelay"
		*/
		private function onDelay(e:Event) {					
			dispatchEvt("onDelay");
			remove();
		}
	}
}