﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.event {
	import flash.events.* ;
	import flash.display.* ;
	import flash.utils.* ;
	import net.flash_line.as3.util.common.* ;	
	import net.flash_line.as3.util.global.* ;	
	import net.flash_line.as3.util.event.* ;	
	import net.flash_line.as3.util.ui.ErrorFrame ;
	/**
     * Dispatched at the end of given period.
	 * @eventType net.flash_line.as3.util.event.EventX.ON_DELAY
	 * @see #dispatchEvt()
     */
    [Event( name="onDelay", type="net.flash_line.as3.util.event.EventX" )]
	/**
	* Send an "onDelay" event after n seconds | n is decimal.
	* Delay2 extends and is similar to Timer.
	* <p>
	* usage :<br/>
	* new Delay2(3).addEventListener(EventX.ON_DELAY,fTimeOut); // FtimeOut Function will be called after 3 seconds<br/>
	* <br/>	
	*/ 
	public class Delay2 extends Timer implements ISuper {
		/**
		* @private
		 *  period - 1/frequency 
		 */
		 protected var pPeriod : Number; 
		
		 include "./../common/isuper.inc.as";
		/**
		* constructor
		* @param	d Delay in second before onDelay event
		*/
		public function Delay2(per:Number=1) {
			super(per*1000,0);
			pPeriod=per*1000;			
			setClassInfo("Delay2",this);
			begin();			
		}
		/**
		* @private
		* start 
		*/
		public function begin () {	
		   addEventListener(TimerEvent.TIMER, onDelay);
           start();
        }
		/**
		* stop  and remove listeners
		* @return null
		*/
		public function remove () : * {				
			stop();
			removeEventListener(TimerEvent.TIMER,onDelay);
			return null;
		}	
		/**
		* alias of remove to test
		*/
		public function clear () : * {	
			//alert("clear in Delay2");
			return remove();
		}	
		
		// Private
		/**
		* listen and transmit event
		* @param	e
		*/
		private function onDelay(e:TimerEvent) {					
			dispatchEvt("onDelay");
			remove();
			e.updateAfterEvent();
			
		}
	
	}
}