﻿/**
*  Send impulsion event -based on ENTER_FRAME- , to a listener .
* setGlobalVar() or appInit() global functions MUST be launched before
* @see net.flash_line.as3.util.event.Clock to have period bases impulse
* @see net.flash_line.as3.util.global.appInit() or setGlobalVar()
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
* @version 0.0.1
*/ 
package net.flash_line.as3.util.event {
	
	import flash.events.* ;
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.common.Var;
	import net.flash_line.as3.util.event.Delegate;
	//
	public class Impulsion extends Super {	
		var pI:Number; 
		var pModulo:Number; 
		var pF:Function; 
		
		/**
		* constructor
		* @param	f 		listener function
		* @param	modulo	modulo
		*/
		public function Impulsion (f:Function,modulo:Number=1) {
			pI=0;
			pModulo=modulo;
			pF=f;
			setClassInfo("Impulsion",this);
			start();
		}
		public function start () {				
			Var.parent.addEventListener(Event.ENTER_FRAME,fOnImpulse);	
			this.addEventListener("onImpulse",pF);
		}
		public function remove () {				
			stop();
		}
		public function stop () {				
			Var.parent.removeEventListener(Event.ENTER_FRAME,fOnImpulse);	
			this.removeEventListener("onImpulse",pF);
		}
		public function fOnImpulse(e:Event) {
			pI++;
			if (Math.floor(pI%pModulo)==0 ) {
				dispatchEvt("onImpulse",{modulo:pModulo});
			}
		}
	}
}
