﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/  
package net.flash_line.as3.util.graph {	
	import flash.display.DisplayObjectContainer ;
	import net.flash_line.as3.util.text.TextFieldX ;
	import net.flash_line.as3.util.global.* ;
	/**
	* Draw an error frame and display message
	*/
	public class  ErrorGraph  extends Graph {
			private var pCr			: Number		;	// corner radius
			private var pBackMc		: RoundRect		;	// back of the frame
			private var pCloseMc	: BasicButton	;	// close button
			private var pTf			: TextFieldX	;
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		* @param	cf		fill color
		* @param	af		fill alpha
		* @param	cl		line color
		* @param	al		line alpha
		* @param 	cr		corner radius
		*/		
		public function ErrorGraph	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100,cf:Number=0xeeeeee,af:Number=.9,cl:Number=0x885555,al:Number=.45,cr:Number=12) {
			super (ctnr.stage,vx,vy,w,h,cf,af,cl,al)	; // remove .stage if bug !
			pCr=cr;			
			pBackMc=new RoundRect(this,0,0,w,h,cf,af,cl,al,cr);
			var txtArea=new RoundRect(this,30,30,w-60,h-70,0xffffff,.35,0,0,cr);
			pCloseMc=new BasicButton(this,w-60,h-30,50,20,0xeeeeff,af,0x0,1,4) ;
			pCloseMc.createButton("over",0xaaddff,1,990000,1);
			pCloseMc.createButton("down",0xddffaa,1,009900,1);
			pCloseMc.setLabel("Fermer",0x555555,null,9) ;  
			pW = w; pH = h;
			
		}
		/**
		* text field
		*/
		public function get tf() :TextFieldX {			
			return pTf;
		}
		/**
		* close button
		*/
		public function get closeMc() :BasicButton  {
			return pCloseMc;
		}
		/**
		* background sprite
		*/
		public function get backMc() :RoundRect  {
			return pBackMc;
		}
		/**
		* Display the error message
		* @param	msg		error message text
		* @param	tc		text color
		* @param	font 	font
		* @param	size	font size
		* @param	bold	true/false
		*/
		public function displayMsg(msg:String,tc:Number=0x0,font:String=null,size=null,bold:Boolean=true) {
			font= getFont(font);
			size= getFontSize(size);	
			pTf	=	new	TextFieldX(this,30,30,pW-60,pH-70,tc,font,size,bold,true);
			//pTf.multiline=true;pTf.wordWrap=true;
			pTf.setText(msg, { align:"center" } );
		}
	}
}