﻿/**
* graph part of node in a tree explorer UI 
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	
	import flash.display.* ;
	import flash.events.* ;

	public class  NodeGraph  extends Graph {
		var pOpener:BasicButton;
		var pHead:BasicButton;
		var pBody:SpriteWithMask;
		var pBodyW:Number;
		var pFontSize:Number;
		
			
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	bw		body width
		* @param	h		height
		*/
		public function NodeGraph	 	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,bw:Number=100,h:Number=100,fontSize:Number=10,cf:Number=0xffffff,af:Number=1,cl:Number=0,al:Number=1) {		
			super (ctnr,vx,vy,w,h,cf,af,cl,al) ;
			pBodyW=bw;
			pFontSize=fontSize;
			create();
			setClassInfo("NodeGraph",this);
		}
		//getter/setter
		/**
		* 
		* @return opener/closer of tree 
		*/
		public function get opener () : DisplayObjectContainer {
			return pOpener  ;
		}
		/**
		* 
		* @return head button upto the tree
		*/
		public function get head () :DisplayObjectContainer {
			return pHead  ;
		}
		/**
		* 
		* @return sprite with mask where is the sub elements of this node
		*/
		public function get body () :DisplayObjectContainer {
			return pBody ;
		}
		/**
		* 
		* @return mask of body
		*/
		public function get msk () :DisplayObjectContainer {
			return pBody.msk ;
		}
		/**
		* 
		* @return masked container of body
		*/
		public function get container () :DisplayObjectContainer {
			return pBody.container ;
		}
		/**
		* 
		* @param	str Header label - node's name
		*/
		public function setLabel (str:String) {
			pHead.setLabel(str,pCl,null,pFontSize,true);
		}		
		//
		//
		/**
		* add a child in masked sprite contener - NOT USED NOW
		* @param	sp 	Sprite to add
		* @param	n		name
		*/		
		public function addInContainer(sp:DisplayObject,vn:String=null) {
			var vy:Number=pBody.containerHeight;
			pBody.addInContainer(sp,0,vy,vn) ;	
			pBody.msk.height=pBody.container.height;
		}
	   /**
		* clear opener and add a displayObject in it
		* @param	sp 	Sprite to add
		*/		
		public function setOpenerGraph(sp:DisplayObject,vn:String=null) {
			sp.width=pH;sp.height=pH;
			pOpener.removeGraphButton () ;
			pOpener.addChildX(sp,vn,0,0) 	;
			pOpener.swapChildren(pOpener.tf, sp);
			pOpener.swapChildren(pOpener.tf,pOpener.mc);
		}
	    /**
		* clear head and add a displayObject in it
		* @param	sp 	Sprite to add
		*/		
		public function setHeadGraph(sp:DisplayObject,vn:String=null) {
			sp.width=pW;sp.height=pH;			
			pHead.removeGraphButton () ;
			pHead.addChildX(sp,vn,0,0) 	;
			pHead.swapChildren(pHead.tf, sp);
			pHead.swapChildren(pHead.tf,pHead.mc);
		}
	   /**
		* create Node
		*/
		public function create() {
			pOpener=new BasicButton	(this,0,0,pH,pH,pCf,pAf,pCl,pAl,6);
			setOpenerLabel("+");
			//
			pHead=new BasicButton	(this,pOpener.width+10,0,pW,pH,pCf,pAf,pCl,pAl,6);
			//
			pBody=new SpriteWithMask(this,pHead.x,pHead.height,pBodyW,1);
			createViewEvent();
			
		}
		//
		// private classes
		//
		private function createViewEvent() {
			pOpener.addEventListener("click",fOpenClose);			
		}	
		private function fOpenClose(e:Event) {
			if (pOpener.tf.text=="+") 	{				
				setOpenerLabel("-");		
			}
			else setOpenerLabel("+");	
		}	
		private function setOpenerLabel(str:String) {
			pOpener.setLabel(str,pCl,null,pFontSize,true);	
		}	
		
	}
}


























