﻿/**
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	
	import flash.display.* ;
	import flash.events.* ;
	import flash.text.*
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.graph.SpriteWithMask ;
	import net.flash_line.as3.util.io.SkinLoader ;
	import net.flash_line.as3.util.ui.ButtonMng ;
	import net.flash_line.as3.util.text.TextFieldX ;
	import net.flash_line.as3.util.text.InputTextField ;
	import net.flash_line.as3.util.global.* ; // used for getFont() at least
	import net.flash_line.as3.util.common.* ; 
	/**
	* create a button with external skin - used with ButtonMng
	*/
	public class  PopUpGraph  extends SpriteX {					
			protected var pTf			: TextFieldX	;
			protected var pBaseUrl		: String	;
			protected var pXmlSkin		: String	;
			protected var pSkinObj		: Object	;
			protected var pSpriteObj		: Object	;
			protected var pScrollable		: Boolean;
			protected var pSl				: SkinLoader	;
			
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	vn		name
		* @param 	baseUrl	Base Url
		* @param 	xmlSkin Url of xml skin
		*/		
		public function PopUpGraph	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,vn:String="popUp",baseUrl:String="",xmlSkin:String="custom/default/popUpSkin.xml") {
			super (ctnr,vx,vy,1,vn)	;
			pXmlSkin=xmlSkin;
			pBaseUrl=baseUrl;
			pScrollable=false;
			setClassInfo("popUpGraph",this);
		}
		//get/set
		
		public function get popModel() :Object  {
			return pSkinObj;
		}
		
			
		/**
		* main TextField
		*/
		public function get tf() :TextFieldX  {
			return pTf;
		}		
		public function get innerArea () :SpriteWithMask  {
			return SpriteWithMask(getSpx("innerArea")) ;
		}		
		public function get msk() :SpriteX  {
			return innerArea.msk ;
		}		
		public function get container() :SpriteX  {
			return innerArea.container ;
		}		
		public function get title() :TextFieldX  {
			return getTfx("title");
		}		
		public function get valid() :SpriteX  {
			return getSpx("valid");
		}		
		public function get validOver() :SpriteX  {
			return valid.getSpx("over");
		}		
		public function get validOut() :SpriteX  {
			return valid.getSpx("out");
		}		
		public function get cancel() :SpriteX  {
			return getSpx("cancel");
		}		
		public function get cancelOver() :SpriteX  {
			return cancel.getSpx("over");
		}		
		public function get cancelOut() :SpriteX  {
			return cancel.getSpx("out");
		}		
		public function get bClear() :SpriteX  {
			return getSpx("clear");
		}		
		public function get bClearOver() :SpriteX  {
			return bClear.getSpx("over");
		}		
		public function get bClearOut() :SpriteX  {
			return bClear.getSpx("out");
		}		
		public function get close() :SpriteX  {
			return getSpx("close");
		}		
		public function get closeOver() :SpriteX  {
			return close.getSpx("over");
		}		
		public function get closeOut() :SpriteX  {
			return close.getSpx("out");
		}	
		// scroll
		public function get scrollable() :Boolean  {
			return pScrollable;
		}		
		public function get scroll() :SpriteX  {
			return getSpx("scroll");
		}		
		public function get scrollUp() :SpriteX  {
			return scroll.getSpx("up");
		}		
		public function get scrollDown() :SpriteX  {
			return scroll.getSpx("down");
		}
		public function get scrollButton() :SpriteX  {
			return scroll.getSpx("button");
		}
		public function get scrollGuide() :SpriteX  {
			return scroll.getSpx("guide");
		}
		public function get wheelArea() :SpriteX  {
			return getSpx("wheelArea");
		}
		// drag sprite - same area than title
		public function get dragSprite() :SpriteX  {
			return getSpx("dragSprite");
		}
		public function get skinLoader() :SkinLoader  {
			return pSl;
		}
		/**
		* load the skin swf
		*/	
		public function loadSkin () {
			pSl=new SkinLoader(this,pBaseUrl);
			pSl.addEventListener("onLoadSkin",fOnLoadSkin);
			pSl.addEventListener(EventX.ON_LOAD_PROGRESS,fOnLoadProgressSkin);
			pSl.load(pXmlSkin);
		}
		public function setTitle (lb:String) {	
			var size:Number= N(pSkinObj.title.size);
			var bold:Boolean= (pSkinObj.title.bold=="true");
			var vx:Number= N(pSkinObj.title.x);
			var vy:Number= N(pSkinObj.title.y);
			var h:Number= N(pSkinObj.title.height);
			var w:Number= N(pSkinObj.title.width);
			var tc:Number= N(pSkinObj.title.textColor);
			new TextFieldX(this,vx,vy,w,h,tc,getFont(),size,bold,true,null,"title").setText(lb,{align:"center"});
			new RectFill(this,vx,vy,w,h,0,0,"dragSprite");
			dragSprite.addEventListener(MouseEvent.MOUSE_DOWN,fStartDrag);
			addEventListener(MouseEvent.MOUSE_UP,fStopDrag);
		}
		
		public function createTextArea () {	
			var vx:Number=N(pSkinObj.innerArea.x);var vy:Number=N(pSkinObj.innerArea.y);
			var h:Number=N(pSkinObj.innerArea.height);var w:Number=N(pSkinObj.innerArea.width);
			var swm:SpriteWithMask=new SpriteWithMask(this,vx,vy,w,h,"innerArea");
			//
			var size:Number= N(pSkinObj.innerArea.size);
			var bold:Boolean= (pSkinObj.innerArea.bold=="true");
			pScrollable= (pSkinObj.innerArea.scroll=="true"  );
			var tc:Number= N(pSkinObj.innerArea.textColor);
			pTf=new TextFieldX(swm.container,0,0,w,h,tc,getFont(),size,bold,true,{type:TextFieldType.INPUT,wordWrap:true,autoSize:TextFieldAutoSize.CENTER,mouseWheelEnabled:false},"mainText");	
			//
		}
		public function createField () {	
			var vx:Number;var vy:Number;var w:Number;var h:Number;var cn:String;var id:String;
			var bold:Boolean;var isPwd:Boolean;var size:Number;var font:String;var tc:Number;var vctnr:SpriteX;var restrict:String;
			var arr:Array=popModel.field.item ;var len:Number=arr.length ;
				for (var i:Number=0;i<len;i++) {
				var o:Object=arr[i];	
				if (strVal(o.id,"")=="") continue ;
				if (strVal(o.x)=="") vx=numVal2(popModel.field.x,0) ; else vx=numVal2(o.x,0)
				if (strVal(o.y)=="") vy=numVal2(popModel.field.y,0) ; else vy=numVal2(o.y,0)
				if (strVal(o.width)=="") w=numVal2(popModel.field.width,200) ; else w=numVal2(o.width,200)
				if (strVal(o.height)=="") h=numVal2(popModel.field.height,20) ; else h=numVal2(o.height,20)
				if (strVal(o.className)=="") cn=strVal(popModel.field.className,"InputTextField") ; else cn=strVal(o.className,"InputTextField") ;			
				if (strVal(o.bold)=="") bold=boolVal(popModel.field.bold,false) ; else bold=boolVal(o.bold,false) ;			
				if (strVal(o.size)=="") size=numVal2(popModel.field.size,12) ; else size=numVal2(o.size,12)		
				if (strVal(o.textColor)=="") tc=numVal2(popModel.field.textColor,0x0) ; else tc=numVal2(o.textColor,0x0)		
				if (strVal(o.font)=="") font=strVal(popModel.field.font,getFont()) ; else font=strVal(o.font,getFont()) ;				
				if (strVal(o.restrict,null)==null) restrict=strVal(popModel.field.restrict,null) ; else restrict=strVal(o.restrict,null) ;				
				isPwd=(strVal(o.displayAsPassword,"false")=="true");
				id=strVal(o.id);
				var str:String=strVal(popModel.field.parent,"root");
				if (str=="root") vctnr=this;
				else vctnr=getSpx(str);
				o.instance=createOneField(vctnr,id,vx,vy,w,h,cn,bold,size,font,tc,restrict,isPwd);
			}
		}
		
		public function setValidButton (lb:String) {	
			setOneButton (lb,valid,"valid",validOut,validOver) ;			
		}
		public function setCancelButton (lb:String) {	
			setOneButton (lb,cancel,"cancel",cancelOut,cancelOver) ;			
		}
		public function setClearButton (lb:String) {	
			setOneButton (lb,bClear,"clear",bClearOut,bClearOver) ;			
		}
		//
		override public function remove () :String {	
			if (dragSprite!=null) dragSprite.removeEventListener(MouseEvent.MOUSE_DOWN,fStartDrag);
			removeEventListener(MouseEvent.MOUSE_UP, fStopDrag);			
			if (parent!=null) parent.removeChild(this);
			return "";
		}
		
		// private
		private function createOneField (vctnr:SpriteX,id:String,vx:Number=0,vy:Number=0,w:Number=200,h:Number=20,cn:String="InputTextField",bold:Boolean=false,size:Number=12,font:String="",tc:Number=0x0,restrict:String=null,isPwd:Boolean=false):DisplayObject {	
			if (cn=="TextField") {				
			} else if (cn=="InputTextField") {	
				var tf:InputTextField=new InputTextField(vctnr,vx,vy,w,h,tc,getFont(font),size,bold,id,isPwd);
				tf.setText("");
				if (restrict!=null) tf.restrict = restrict ;
				return tf;
			} else if (cn=="TextInput") {
			} else if (cn=="ComboBox") {
			} else if (cn=="TextArea") {
			} else if (cn=="RadioButton") {
			} else if (cn=="CheckBox") {				
			} else {
				return null;
			}
			return null;
		}
		protected function setOneButton (lb:String,bCtnr:SpriteX,vname:String,onOut:SpriteX,onOver:SpriteX) {	
			bCtnr.visible=true;
			var bg:ButtonGraph=new ButtonGraph(this,bCtnr.x,bCtnr.y,bCtnr.width,bCtnr.height);
			bg.addSkin(onOver,"over");bg.addSkin(onOut,"out");
			bCtnr.remove();bg.name=vname;			
			bg.setLabel(lb,N(pSkinObj.buttonLabel.y),N(pSkinObj.buttonLabel.textColor),null,N(pSkinObj.buttonLabel.size),(pSkinObj.buttonLabel.bold=="true"))
			new ButtonMng(getSpx(vname),onOut,onOver,onOver);onOver.visible=false;onOut.visible=true;
		}
		
		private function fOnLoadSkin (e:EventX) {			
			pSl.removeEventListener("onLoadSkin",fOnLoadSkin);
			pSkinObj=pSl.skinObject;
			pSl.removeEventListener("onLoadSkin",fOnLoadSkin);
			pSl=pSl.remove();
			new ButtonMng(close,closeOut,closeOver,closeOver);closeOver.visible=false;closeOut.visible=true;	
			dispatchEvt("onLoadPopUp",{instance:this});				
		}
		private function fOnLoadProgressSkin (e:EventX) {			
			dispatchEvt(EventX.ON_LOAD_PROGRESS,{total:e.srcVar.total,loaded:e.srcVar.loaded});				
		}
		private function fStartDrag(e:MouseEvent) {
			dispatchEvt("onSelect",{instance:this});	
			startDrag();
		}
		private function fStopDrag(e:MouseEvent) {
			stopDrag();
		}
	}
}