﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	import flash.geom.*
	import flash.display.* ;
	/**
	* Instance a sprite with fill part of rectangle 
	*/ 
	public class  RectGrad  extends RectFill {
		/**
		* gradient second color
		*/
		protected		var pC2			: Number		;	//
		/**
		* gradient second alpha
		*/
		protected		var pA2			: Number		; 	//
		/**
		* gradient rotation
		*/
		protected		var pR			: Number		; 	//
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		* @param	cf		color
		* @param	af		alpha
		* @param	c2		2nd color 
		* @param	a2		2nd alpha
		* @param	r		gradient rotation in degree
		* @param 	vName	name of the created sprite
		*/
		public function RectGrad	 	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100,cf:Number=0xff0000,af:Number=1,c2:Number=0x00ffff,a2:Number=1,r:Number=0,vName:String="") {		
			super (ctnr,vx,vy,w,h,cf,af) ;	
			pC2=c2;
			pA2=a2;
			pR=r;
			name=vName;
			create();
			setClassInfo("RectGrad",this);
		}
		
	   /**
		* create form
		*/
		private function create() { 
			// begin and ending colors - may be more than 2 colors
			var colors:Array = [pCf, pC2];
			// begin and ending alphas - idem
			var alphas:Array = [pAf, pA2];
			// balanced ratio for 2 colors - with 3 colors a balanced ratio would be 0x00, 0x7F , 0xff hexa ~ 0,127,255 decimal 
			// colors , alphas and ratios must have the same number of entries.
			var ratios:Array = [0x00, 0xFF];
			// Create the gradient descriptive Matrix
			var mtx:Matrix = new Matrix(); 
			// the rotation of gradient must be given in radians
			var radians:Number = (pR / 180) * Math.PI;  
			// define gradient parameters in a matrix
			mtx.createGradientBox(pW, pH, radians);
			// prepare gradient visualy with parameters :
			//// gradient type (GradientType.RADIAL or GradientType.LINEAR)
			//// colors Array , alphas Array , ratios , the Matrix 
			//// an other type for gradient : SpreadMethod.PAD = normal ; SpreadMethod.REFLECT = repeat symetricly ; SpreadMethod.REPEAT = basic repeat.
			graphics.beginGradientFill(GradientType.LINEAR, colors, alphas, ratios, mtx, SpreadMethod.PAD); 
			// draw an effective form in the DisplayObject
			graphics.drawRect(0,0,pW,pH);  
		}		
	}
}