﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	
	import flash.display.DisplayObjectContainer ;
	/**
	* Instance a sprite with a rounded corner rectangle - fill and line 
	*/ 
	public class  RoundRect  extends Graph {
			protected		var pCr			: Number		;	// corner radius
			protected		var pFillMc		: RoundRectFill	;	
			protected		var pLineMc		: RoundRectLine	;	
			
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		* @param	cf		fill color
		* @param	af		fill alpha
		* @param	cl		line color
		* @param	al		line alpha
		* @param 	cr		corner radius
		*/
		public function RoundRect	 	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100,cf:Number=0xffffff,af:Number=1,cl:Number=0x0,al:Number=1,cr:Number=8) {
			super (ctnr,vx,vy,w,h,cf,af,cl,al) ;
			pCr=cr;
			create();
			setClassInfo("RoundRect",this);
		}
		/**
		* getter/setter
		*/
		/**
		* fill container
		*/
		public function  get fillMc () : DisplayObjectContainer {
			return pFillMc ;
		}
		/**
		* line container
		*/
		public function  get lineMc () : DisplayObjectContainer {
			return pLineMc ;
		}
		/**
		* create form
		*/
		protected function create() {
			pFillMc=new RoundRectFill	 	  ( this,0,0,pW,pH,pCf,pAf,pCr) ;
			pLineMc=new RoundRectLine	 	  ( this,0,0,pW,pH,pCl,pAl,pCr) ;
		}
		
	}
}