﻿/**
* A sprite within a square mask and inner sprite masked
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	
	import flash.display.* ;

	public class  SpriteWithMask  extends Graph {
		var pMsk:RectFill;	
		var pContainer:Graph;	
			
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		*/
		public function SpriteWithMask	 	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100,vn:String="") {		
			super (ctnr,vx,vy,w,h) ;
			name=vn;
			create();
			setClassInfo("SpriteWithMask",this);
		}
		//getter/setter
		/**
		* 
		* @return mask sprite
		*/
		public function get msk () :RectFill {
			return pMsk  ;
		}
		/**
		* 
		* @return masked content sprite
		*/
		public function get container () :Graph {
			return pContainer  ;
		}
		/**
		* 
		* @return content height
		*/
		public function get containerHeight () :Number {
			return pContainer.height ;
		}
		/**
		* 
		* @return mask width
		*/
		public function get mskWidth () :Number {
			return pMsk.width ;
		}
		/**
		* 
		* @return mask height
		*/
		public function get mskHeight () :Number {
			return pMsk.height ;
		}
		/**
		* 
		* @param	n new width of mask
		*/
		public function set mskWidth (n:Number)  {
			pMsk.width=n ;
		}
		/**
		* 
		* @param	n new height of mask
		*/
		public function set mskHeight (n:Number) {
			pMsk.height=n ;
		}
		//
		//
		/**
		* add a child in masked sprite contener
		* @param	sp 	Sprite to add
		* @param	n		name
		*/		
		public function addInContainer(sp:DisplayObject,vx:Number=0,vy:Number=0,vn:String=null) {
			pContainer.addChildX(sp,vn,vx,vy); 
		}
	   /**
		* create msk and container
		*/
		public function create() {
			pContainer=new Graph(this,0,0,pW,1);pContainer.init();
			pMsk=new Msk(this,pContainer,0,0,pW,pH);
			
		}	
		override public function remove () : String{
			pContainer.remove();
			pMsk.remove();
			if (parent!=null) parent.removeChild(this);
			return "";
		}
	}
}
