﻿/**
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.graph {	
	
	import flash.display.* ;
	import flash.text.*
	import net.flash_line.as3.util.text.TextFieldX ;
	import net.flash_line.as3.util.global.* ; // used for getFont() at least
	import net.flash_line.as3.util.common.* ; 
	/**
	* create a button with external skin - used with ButtonMng
	*/
	public class  ButtonGraph  extends Graph {
			var pMc			: RectFill	;	// mouse interactive hidden button			
			var pTf			: TextFieldX	;
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		*/		
		public function ButtonGraph	  ( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100) {
			super (ctnr,vx,vy,w,h)	;
			createMainButton(pW,pH);
			setClassInfo("ButtonGraph",this);
		}
		//get/set
		
		/**
		* main,interactive and not visible button
		*/
		public function get mc() :RectFill  {
			return pMc;
		}		
		/**
		* button label TextField
		*/
		public function get tf() :TextFieldX  {
			return pTf;
		}		
		
		//
		/**
		* create interactive and not visible button
		* @param	w	width
		* @param	h	height
		*/public function createMainButton( w:Number=100,h:Number=100) {
			if (pMc!=null) pMc.remove();
			pMc=new RectFill(this,0,0,w,h,0,0,"click");			
		}
		/**
		* add a visible skin
		* @param	sp the skin sprite
		* @param n name
		*/
		public function addSkin(sp:DisplayObject,n:String) {			
			addChildX(sp,n,0,0) 
			swapChildren(pMc, sp);
			if (pTf != null) {
				if (getChildIndex(pTf)<getChildIndex(sp)) {
					swapChildren(pTf, sp);
				}
			}
		}		
		/**
		* get skin element
		* @param	n skin elem name
		*/
		public function getSkin(n:String) : DisplayObject {			
			return getChildByName(n);
		}		
		/**
		* set label textfield
		* @param	lb		label
		* @param	tc		text color
		* @param	font	font name
		* @param	size	font size
		* @param	bold	true/false
		*/
		public function setLabel(lb:String,vy:Number=0,tc:Number=0x0,font:String=null,size=null,bold:Boolean=true,tfo:Object=null,txf:TextFormat=null) {
			if (tfo == null) tfo = { align:"center" };
			if (pTf!=null) pTf.remove();
			font= getFont(font);
			size= getFontSize(size);
			pTf	=	new	TextFieldX(this,0,vy,pW,pH-2,tc,font,size,bold,true,null,"label");	
			pTf.setText(lb,tfo,txf ) ;
			swapChildren(pTf, pMc);				
		}
		public function setLabelXY(lb:String,vx:Number=0,vy:Number=0,tc:Number=0x0,font:String=null,size=null,bold:Boolean=true,tfo:Object=null,txf:TextFormat=null) {
			if (tfo == null) tfo = { align:"center" };
			if (pTf!=null) pTf.remove();
			font= getFont(font);
			size= getFontSize(size);
			pTf	=	new	TextFieldX(this,vx,vy,pW,pH-2,tc,font,size,bold,true,null,"label");	
			pTf.setText(lb,tfo,txf ) ;
			swapChildren(pTf, pMc);				
		}
	}
}