﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.io {		
	import flash.events.* ;
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.common.* ;	
	import net.flash_line.as3.util.event.* ;
	
	/**
	* Preload then remove a batch of file .
	*
	*/ 
	public class PreLoader extends Super {
		var pBl:BatchLoader;
		var pToDoAfterLoad:Boolean;
		public static const NOT_REMOVE_IMAGE : Boolean = false ;
		public static const REMOVE_IMAGE : Boolean = true ;
		public static const VIDEO_INIT : String ="videoInit" ;
		/**
		* constructor
		*/
		public function PreLoader () {		
			setClassInfo("PreLoader",this);
			pToDoAfterLoad=REMOVE_IMAGE;
		}
		//get/set
		/**
		* Launch the input BatchLoader's loading
		* @param bl A valid BatchLoader instance ready to be loaded
		*/
		public function load(bl:BatchLoader=null,toDoAfterLoad:Boolean=true) {
			pToDoAfterLoad=toDoAfterLoad;
			if (bl!=null) {
				pBl=bl;
				pBl.addEventListener(EventX.ON_LOAD_BATCH,fOnLoadBatch);
				pBl.addEventListener(EventX.ON_LOAD_ERROR,fOnLoadError);
				pBl.load();	
			}
		}
		
		/**
		* remove listeners and BatchLoader instance
		* @return null
		*/
		public function remove() {
			if (pBl!=null) {
				pBl.removeEventListener(EventX.ON_LOAD_BATCH,fOnLoadBatch);
				pBl.removeEventListener(EventX.ON_LOAD_ERROR,fOnLoadError);	
				pBl.remove();
			}
			return null;
		}
		
		//
		// private
		//
		private function fOnLoadBatch(ex:EventX) {
			finishPreload();
		}
		private function fOnLoadError(ex:EventX) {
			finishPreload()
		}
		private function finishPreload() {
			if (pBl && pToDoAfterLoad==REMOVE_IMAGE) pBl.removeLoadedFile();			
			remove();
			dispatchEvt(EventX.ON_LOAD_BATCH);
		}
		
		
		
	}//End of Class PreLoader
}
