﻿/**
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.io {
	import flash.display.*;
	import flash.text.TextField;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	//
	public class ProgressMng extends Super {
		// Properties		
			protected		var	pTarget		: DisplayObjectContainer ; 	// Progress bar MC
			protected		var	pProgress	: DisplayObject	;	//  bar - dynamic part of mc
			protected 		var pTF			: TextField ; 	// Progress bar textField
			protected		var pText		: String	;	// Text displayed
			protected 		var pPercentOnly: Boolean	;	// Display only % value. pText must be undefined
		/**
		* constructor
		* @param	vTarget			progress clip
		* @param	vProgress		bar - dynamic part of mc
		* @param	vTF				Progress bar textField
		* @param	vText			Text displayed
		* @param	vPercentOnly 	True = Display only % value. pText must be empty
		*/
		public function ProgressMng  ( vTarget:DisplayObjectContainer,vProgress:DisplayObject,vTF:TextField,vText:String="",vPercentOnly:Boolean=true) {
			pTarget				= vTarget;
			pProgress			= vProgress;
			pTF					= vTF ;
			pText				= vText ;
			pProgress.scaleX 	= 0 ;		
			pTF.text="";
			pPercentOnly = vPercentOnly ;
			setClassInfo("ProgressMng",this);
		}
	  
	   //------Public method ------ 
		public function get sp () : DisplayObjectContainer {
			return pTarget ;
		}	
		public function set text (str:String) {
			pText=str;
		}	
		/// Display progression
		public function display(vLoaded,vTotal) {			
			if ( vLoaded<=0) {
				pTarget.visible=false;				
			} else {
				pTarget.visible=true;	
				if (vTotal>0) {			
					var vUnit 		= 1000 ;
					var vUnitTxt 	= " kb";		
					if (vTotal < 1000) {
						vUnit 		= 1 ;
						vUnitTxt 	= " bytes";
					} 
					pProgress.scaleX=vLoaded/vTotal ;
					if (pPercentOnly) {
						pTF.text = pText+" "+(Math.round(pProgress.scaleX*100)+" %");
					}  else if (strVal(pText,"") != "") {
						pTF.text =(pText+" : Total= "+Math.floor(vTotal/vUnit)+vUnitTxt+" / chargé= "+Math.floor(vLoaded/vUnit)+vUnitTxt);
					}
				} else {			
					if (strVal(pText,"") != "") {
						pTF.text =pText;
					} 
				}
			}
		}
		//
		public function remove() {	
			sp.parent.removeChild(sp);
		}
		public function hide() {	
			sp.visible=false ;
		}
		public function show() {	
			sp.visible=true ;
		}
		 //------Private method ------ 
		
	}
}
		
		