﻿/**
* I/O flnet'API package
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.io {	
	import flash.display.DisplayObjectContainer;
	import flash.events.EventDispatcher;
	import net.flash_line.as3.util.event.EventX;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.common.SpriteX;
	import net.flash_line.as3.util.io.LoaderX;
	
	
	/**
	* Abstract super class to
	* load an swf with named MCs hierarchy. The swf is generally one of the main skins of an app.
	*/
	public class SwfSkinLoader extends EventDispatcher  {
		// Properties		
		protected var _ctnr: DisplayObjectContainer;
		protected var _loadErrMsg:String;
		protected var _skinIsLoaded:Boolean;
		protected var _skin:LoaderX;
		/**
		 * Constructor
		 * @param	ctnr		generally root sprite of application
		 */
		public function SwfSkinLoader  ( ctnr:DisplayObjectContainer,loadErrMsg:String = "Skin not found" ) {
			_ctnr = ctnr;
			_loadErrMsg = loadErrMsg;
			
		}
		//gets/set
		/**
		 * Container of main skin
		 */
		public function get ctnr () : DisplayObjectContainer  {
			return _ctnr
		}
		public function set ctnr (doc: DisplayObjectContainer)  {
			_ctnr=doc
		}
		/**
		 * skin sprite
		 */
		public function get skin () : SpriteX {
			return _skin ;
		}
		
		/**
		 * true if  skin loading is finished correctly
		 */
		public function get skinIsLoaded () : Boolean {
			_skinIsLoaded = boolVal(_skinIsLoaded, false);
			return (_skinIsLoaded && skin != null) ;
		}
		public function set skinIsLoaded (b: Boolean)  {
			_skinIsLoaded = b;
		}
		
		
		
		
		//------Public method ------ 
		
		/**
		 * remove and free memory instance of this class.
		 * @return Null
		 */
		public function remove() : Object {				
			removeLoadSwfSkinListener ();			
			if (skinIsLoaded) {				
				LoaderX(skin).remove();
				_skin = null;	
			}	
			return null;
		}		
		
		/**
		 * Load skin as an external swf
		 * @param	str swf Url
		 * @param	vx y location
		 * @param	vy y location
		 */
		public function loadSwfSkin(src:String = null, vx:Number = 0, vy:Number = 0)  {	
			//
			_skin=new LoaderX(_ctnr,src,vx,vy);
			_skin.addEventListener(EventX.ON_LOAD_COMPLETE, onLoadSwfSkin);
			_skin.addEventListener(EventX.ON_LOAD_ERROR, onErrorSwfSkin);			
		}
		/**
		 * Remove skin swf's XmlParser listeners.
		 * This method is automaticly called when skin swf file is loaded.
		 * @param	xlp
		 */
		public function removeLoadSwfSkinListener() {
			if (_skin != null) {
				_skin.removeEventListener(EventX.ON_LOAD_COMPLETE, onLoadSwfSkin);
				_skin.removeEventListener(EventX.ON_LOAD_ERROR, onErrorSwfSkin);
			}
		}		
		
		/**
		* @private or protected methods
		*/			
	    protected  function onLoadSwfSkin (e:EventX):void {	
			skinIsLoaded = true;
			removeLoadSwfSkinListener();
			dispatchEvent(new EventX("onLoadSwfSkin"));
			
		}	   
	    protected function onErrorSwfSkin(e:EventX) {
			removeLoadSwfSkinListener();
			error(_loadErrMsg);	
			dispatchEvent(new EventX("onErrorSwfSkin"));
		}	
		
	}
}
		
		