﻿/**
* instance a new Object from a specific tree Object
* to may extract subtree easely AND in the original order
* To order correctly we use an Array - children.child - same in xml markup- 
* 
* @see flash-line trees xml file
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
//
package net.flash_line.as3.util.memory {	
	//
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	//	
	public class  MemTree   {
		var pTree:Object;
		var pCtnrName:String;
		var	pArrName:String;
		
		/**
		* constructor
		* @param 	tree Tree Object - Object with a property children.child:Array  as  {}.children.child[n].{id:xx,<other properties>}
		* @param	cn		container's name of the Array - container is an Object
		* @param	an		The Arrayname
		*/
		public function MemTree (tree:Object,cn:String="children",an:String="child") { 
			pTree=tree;
			pCtnrName=cn;
			pArrName=an;
		}
		/**
		* 
		* @param	target	An Array of String which describe the tree of searched sub object
		* @return 	An Object : the subtree we are looking for
		*/
		public function getElem (target:Array=null) :Object{ 
			if (target==null) {
				return pTree;
			} else {
				return searchElem(pTree,target,0);
			}
		}
		/**
		* 
		* @param	target	An Array of String which describe the tree of searched sub object
		* @return	The Array of the subtree we are looking for - nested tree
		*/
		public function getList (target:Array=null) :Array{ 
			if (target==null) {
				if (listExist()) return pTree[pCtnrName][pArrName];
				else return null;				
			} else {
				var se:Object;
				se=searchElem(pTree,target,0);
				if (se!=null) {
					if (listExist(se)) return se[pCtnrName][pArrName];
					else return null;
				} else return null;
					
			}
		}
		/**
		* remove this class and return null. Usage : memTree=memTree.remove();
		*/
		public function remove ()  {
			pTree=null;
			return null;
		}
		//
		// private
		//
		private function searchElem (o:Object,target:Array,current:Number) :Object { 
			var st:Object;		
			o=firstWithList(o);
			if (listExist(o) ) {
				var arr:Array=o[pCtnrName][pArrName];
				var id:String=target[current];			
				current++;
				if (current<target.length) st=searchElem(Memo.returnObjectOfId (arr,id),target,current);
				else st=Memo.returnObjectOfId (arr,id);
			} else st=null;
			return st;
		}
		private function listExist (o:Object=null) :Boolean { 
			if (o==null) o=pTree;
			if (o[pCtnrName]==null) return false ;
			if (o[pCtnrName][pArrName]==null) return false ;
			return true ;
		}
		private function firstWithList (o:Object) :Object { 
			if (o==null) return null;
			if (listExist(o)) return o ;
			for (var i in o) {
				if (listExist(o[i])) return o[i];
			}
			return firstWithList(o[i]);
		}
		//
		
		
		
	}
}