﻿/**
* Tween with equation ex: y = 60*Math.cos(x/60);
* 
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
* @version 0.0.1
*/ 
package net.flash_line.as3.util.motion {
	
	import flash.events.* ;
	import flash.display.* ;
	import net.flash_line.as3.util.common.Super ;
	import net.flash_line.as3.util.event.* ;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import fl.transitions.TweenEvent ;
	//
	public class EqTween extends BasicTween {	
		var pEq:Function;
		/**
		* constructor and launch Tween
		* @param	mc		tweened clip
		* @param	prop	property
		* @param	e		end value
		* @param	eq		MOTION_CHANGE function listener
		* @param	d		duration
		* @param	f		easing function
		* @dispatch TweenEvent.MOTION_CHANGE
		*/
		public function EqTween(mc:DisplayObject,prop:String,e:Number,eq:Function,d:Number=.5,f:Function=null) {
			super(mc,prop,e,d,f);
			pEq=eq;
			if (isNaN(e)){
				error("   -> In EqTween "+e+" is not a number !");
			}
			pTween.addEventListener(TweenEvent.MOTION_CHANGE,pEq);	
			setClassInfo("EqTween",this);
		}
	}
}

