﻿/**
* FLnet util API
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.motion {
	import flash.events.* ;
	import flash.display.* ;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;	
	import net.flash_line.as3.util.event.*; 
	public class Pursuit extends Super {	
		private var pMc:Sprite;
		private var pBrother:Sprite;
		private var pShftX:Number; 
		private var pShftY:Number;
		private var pClk:Clock;
		private var pLimitx:Number;
		private var pType:Number;
		private var pFunc:Array;
		private var pDur:Number;
		

		public function Pursuit(mc:Sprite,brother:Sprite,d:Number=6) {
			setClassInfo("Pursuit",this);
			if (mc!=null && brother!=null) {
				pMc=mc;
				pBrother=brother;
				pShftX=mc.x-brother.x;
				pShftY=mc.y-brother.y;
				pDur=d;
			}
			start();
		}
	/*
	start/stopEvent
	*/
		public  function stop() {	
			remove();
		}
		public  function start() {	
			pClk=new Clock(fDoPursuit,.01);
		}
		public  function remove() {	
			if (pClk!=null) pClk=pClk.remove();
			stack.clear();
		}
	/* 
	get /set
	*/
		public function get sp () :Sprite{
			return pMc;
		}
		public function get mc () :Sprite{
			return pMc;
		}
		public function get brother ():Sprite {
			return pBrother;
		}
		public function get sx ():Number {
			return pShftX;
		}
		public function get sy ():Number {
			return pShftY;
		}
		
		public function set sp (mc:Sprite) {
			pMc=mc;
		}
		public function set mc (mc:Sprite) {
			pMc=mc;
		}
		public function set brother (mc:Sprite) {
			pBrother=mc;
		}
		public function set sx (n:Number) {
			pShftX=n;
		}
		public function set sy (n:Number) {
			pShftY=n;
		}
		
	/*
	@method fClock General clock impulse
	*/	
		
		
		private function fDoPursuit(te:TimerEvent) {	
			if ( brother.x+sx!=mc.x ) {	
				var d=pDur;var s=mc.x;var e=brother.x+sx;
				if (Math.abs(s-e)<=1) {
					mc.x=e;
				} else {
					stack.push(new BasicTween(pMc,"x",e,d,null,false));
					stack.last.addEventListener(EventX.ON_END_TWEEN,fRemoveTween);
				}
			}
			if ( brother.y+sy != mc.y ) {
				s=mc.y;e=brother.y+sy ; d=pDur;
				if (Math.abs(s-e)<=1) {
					mc.y=e;
				} else {
					stack.push(new BasicTween(pMc,"y",e,d,null,false));
					stack.last.addEventListener(EventX.ON_END_TWEEN,fRemoveTween);
				}
				
			}	
		}
		private function fRemoveTween(ex:EventX) {	
			
			var t:BasicTween=ex.srcVar.tween;
			t.removeEventListener(EventX.ON_END_TWEEN,fRemoveTween);
			t.remove();
		}


	}
}

