﻿/**
* application's controler
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.mvc {	
	import flash.display.Sprite ;
	import flash.text.TextField ;	
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.io.ProgressMng ;
	//
	public class AbstractControler extends Super {
		var pModel:*;
		var pMain:*;
		var pView:*;
		var pModelUrl:String;
		var pClock:Clock;
		private var pProgressMng:ProgressMng;
		
		public function AbstractControler (mn:*) {
			setClassInfo("AbstractControler",this);	
			pMain = mn;
			pView = pMain.view;
			pModel=pMain.model;
		}
//getter/setter
		
		public function get _main ():* {
			return pMain;
		}
		public function get clock ():Clock {
			return pClock;
		}
		public function set clock (c:Clock) {
			pClock=c;
		}
		//
		//
		/**
		* 
		* @return model tree
		*/
		public function get param() :Object  {
			return pModel.tree;
		}
		/**
		* start of controler  - may be override
		* <p>Launch progress bar
		* Call xml model loading
		* Call skin loading
		* If all is okay : Call Controler.onFirstAppliEvent() which must exist and be override in the subclass Controler
		* </p>
		* @param	modelUrl model xml filename
		*/	
		public function begin (modelUrl:String, progressFile:String) {
			pModelUrl = modelUrl;
			if (strVal(progressFile,"")!="") pView.showProgress(progressFile);
			pView.addEventListener("onLoadProgress",fOnLoadProgress);
		}
		//		
		/**
		* listen end of progress bar load.
		* may be override
		* @param	e Event object
		*/
		// - 
		public function fOnLoadProgress (e:EventX) {
			pView.removeEventListener("onLoadProgress",fOnLoadProgress);
			var bar:Sprite=Sprite(pView.progress.getChildByName("progress"));
			var tf:TextField=TextField(pView.progress.getChildByName("tf"));	
			if (bar!=null && tf!=null) {				
				pProgressMng=new ProgressMng(pView.progress,bar,tf);
				//pView.progress.visible=false; // not needed
			}
			pModel.addEventListener("onLoadModel",fOnLoadModel);
			pModel.loadModel(pModelUrl);	
		}
		/**
		* listen end of model xml file loading
		* @param	e Event object
		*/
		// - may be override
		public function fOnLoadModel (e:EventX) : void {
			if (pModel.isWithSkin) {
				pView.loadSkin();
				if (pProgressMng!=null) pView.addEventListener("onProgressSkin",fOnProgressSkin);
				pView.addEventListener("onLoadSkin",fOnLoadSkin);
			} else {
				fOnLoadSkin(new EventX("null"));
			}
			pMain.stage.frameRate=pModel.frameRate;			
			
		}
		/**
		* listen end of skin loading - may be override
		* @param	e Event object
		*/
		public function fOnLoadSkin (e:EventX) : void {			
			if (pProgressMng!=null) {
				pView.progress.visible=false;
				pView.removeEventListener("onProgressSkin",fOnProgressSkin);
			}
			else pView.hideProgress();	
			pView.removeEventListener("onLoadSkin",fOnLoadSkin);
			createEvent();
			
		}	
		public function fOnProgressSkin (e:EventX) : void {
			if (pProgressMng!=null) pProgressMng.display(e.srcVar.loaded,e.srcVar.total);
		}	
		/**
		* create main listeners and events - may be override
		*/
		// - 
		public function createEvent () {
			onFirstAppliEvent();
			//ex : pView.button.addEventListener("click",fRelease);
		}
		/**
		* Ready  - Must be override in subclass controler
		*/
		public function onFirstAppliEvent() {
			
			
		}

		

		
		
	}//End of Class AbstractControler
}
