﻿/**
* Abstract MVC View class
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.mvc {	
	//
	import flash.display.* ;
	import flash.text.* ;
	import flash.events.* ;
	//import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.common.Super ;
	//import net.flash_line.as3.util.motion.* ;
	import  net.flash_line.as3.util.common.SpriteX;	
	import net.flash_line.as3.util.event.* ;
	import net.flash_line.as3.util.io.LoaderSprite ;
	import net.flash_line.as3.util.io.SkinLoader ;
	//import net.flash_line.as3.util.graph.Msk ;
	//import fl.transitions.easing.*;
	//
	public class AbstractView extends Super {
					var pMain:*;
					var pModel:*;
					var pLs:LoaderSprite;
					var pClock:Object; 
					var pProgress:LoaderSprite; 
					var pSl:SkinLoader; 
		protected 	var pSkin:Object; 
		
		public function AbstractView (mn:*, prt:SpriteX) {		
			setClassInfo("AbstractView",this);	
			pMain = mn;
			pModel = pMain.model ;
			rootParent=prt;
			pClock={};
		}
		// get/set
		public function get _main ():* {
			return pMain;
		}
		public function get progress() : SpriteX  {
			return pProgress;
		}
		public function get skinObject() :Object  {
			return pSkin;
		}
		public function get param() :Object  {
			return pModel.param;
		}
		/**
		* container sprite of the loaded skin - may be override
		*/
		public function get parentCtnr() :SpriteX  {
			return rootParent;
		}
		public function get stage() :Stage  {
			return rootParent.stage;
		}
		public function getSpx(str:String) :SpriteX  {
			var spx:SpriteX=SpriteX(parentCtnr.getChildByName(str));
			return spx;
		}
		public function getMc(str:String) :MovieClip  {
			var mc:MovieClip=MovieClip(parentCtnr.getChildByName(str));
			return mc ;
		}
		public function getSp(str:String) :Sprite {
			var sp:Sprite=Sprite(parentCtnr.getChildByName(str));
			return sp ;
		}		
		public function getTf(str:String) :TextField  {
			return parentCtnr.getChildByName(str) as TextField ;
		}
		public function getTfVal(str:String) :String  {
			return getTf(str).text ;
		}
		public function hideMain () {	
			parentCtnr.visible=false;
		}
		public function hideAll () {	
			for (var i:uint=0; i<pParent.numChildren; i++) {
				parentCtnr.getChildAt(i).alpha=0;				
			}	
		}
		public function showMain () {	
			parentCtnr.visible=true;
		}
		/**
		* load the skin swf
		*/	
		public function loadSkin () {	
			pSl=new SkinLoader(parentCtnr,pModel.baseUrl);
			pSl.addEventListener("onLoadSkin",fOnLoadSkin);
			pSl.addEventListener(EventX.ON_LOAD_PROGRESS,fOnProgressSkin);
			pSl.load(pModel.xmlSkin);
		}
		private function fOnProgressSkin (e:EventX) {
			dispatchEvt("onProgressSkin",{total:e.srcVar.total,loaded:e.srcVar.loaded});				
		}
		private function fOnLoadSkin (e:EventX) {
			pSkin=pSl.skinObject;
			pSl.removeEventListener("onLoadSkin",fOnLoadSkin);
			pSl=pSl.remove();
			dispatchEvt("onLoadSkin");				
		}
		public function showProgress (src:String, vx = null, vy = null) : SpriteX {	
			hideProgress();
			if (vx==null) vx=Number(pMain.stage.stageWidth/2); 
			if (vy==null) vy=Number(pMain.stage.stageHeight/2);
			var ls:LoaderSprite=new LoaderSprite(pMain,src,vx,vy);
			ls.addEventListener("onLoadComplete",Delegate.pass(fOnLoadProgress,ls));
			return SpriteX(ls);
		}
		private function fOnLoadProgress (e:EventX,ls:LoaderSprite) {			
			ls.removeEventListener("onLoadComplete",null);
			pProgress=ls;
			dispatchEvt("onLoadProgress");
		}
		public function hideProgress () {
			pProgress=pMain.removeChildX(pProgress);
		}
		public function displayErrorMsg (str:String) {	
			error(str);		
		}

	}//End of Class AbstractView
}
