﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.text {	
	import flash.display.DisplayObjectContainer ;
	import flash.text.* ;
	import net.flash_line.as3.util.event.EventX ;
	import net.flash_line.as3.util.ui.ErrorFrame ;
	import net.flash_line.as3.util.common.* ;
	import net.flash_line.as3.util.global.* ;
	/**
	* Extend TextField 
	*/
	public class  TextFieldX  extends TextField implements ISuper {
		
		private var pCtnr		: DisplayObjectContainer		; 	// parent contener 			
		private var pTf			: TextFormat					; 	//save of used TextFormat	
		private var pTc			: Number						;	// textColor
		private var pFont		: String				;	
		private var pSize		: Number				;	
		private var pBold		: Boolean				;	

		include "../common/isuper.inc.as";
		/**
		* constructor
		* @param	ctnr	Container parent
		* @param	vx		x pos
		* @param	vy		y pos
		* @param	w		width
		* @param	h		height
		* @param	tc		text color
		* @param	font	font name
		* @param	size	font size
		* @param	bold	bold true/false
		* @param	embed	embed font true/false
		*/
		public function TextFieldX( ctnr:DisplayObjectContainer,vx:Number=0,vy:Number=0,w:Number=100,h:Number=100,tc:Number=0x0,font:String="Verdana",size:Number=12,bold:Boolean=false,embed:Boolean=false,tfo:Object=null,vname:String="") {
			super();	
			pCtnr		= ctnr	;
			pCtnr.addChild(this);
			x 			= vx;
            y			=vy;
            width 		= w;
            height		= h;		
			textColor	= tc;
			embedFonts	=embed;
			pFont=font;
			pTc=tc;
			pSize=size;
			pBold=bold;	
			name=vname;
			multiline=true;
			if (tfo!=null) {
				for (var i:String in tfo) {
					this[i]=tfo[i];
				}
			}
			if (autoSize==TextFieldAutoSize.NONE) wordWrap=true;
			setClassInfo("TextFieldX",this);
		}
		/**
		* Set text property
		* @param	txt	a string value
		* @param	tfo	An object to copy to the TextFormat of this
		* @param	tf	An external TextFormat to assign to this
		*/	  	
		public function setText(txt:String="",tfo:Object=null,tf:TextFormat=null) {
			pTf = tf ;
			if (pTf==null) {	
				pTf		= new TextFormat(pFont,pSize,pTc,pBold);
			}			
			if (tfo!=null) {
				for (var i:String in tfo) {
					pTf[i]=tfo[i];
				}
			}
			defaultTextFormat = pTf;
			text = txt;
			setTextFormat(pTf);
		}
		public function setFormat(tfo:Object,s:Number,e:Number) {			
			var ntf=new TextFormat();
			for (var i:String in tfo) {
				ntf[i]=tfo[i];
			}			
			setTextFormat(ntf,s,e);			
		}
		
		/**
		* remove created object from parent container
		* @return null
		*/		
		public function remove() : * {
			pCtnr.removeChild(this); 	
			return null ;
		}
	}
}

	