﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui {		
	import flash.display.DisplayObject ;
	import flash.display.Sprite;
	import flash.events.Event ;
	import net.flash_line.as3.util.common.Super;
	import net.flash_line.as3.util.event.Delegate;
	import net.flash_line.as3.util.global.*;
	/**
	* Button manager.
	* <p>ButtonMng addListeners and change visible status for RollOver,Out,Down events</p>
	*/
	public class  ButtonMng  extends Super {
			private		var pMc			: DisplayObject		;	
			private		var pOutMc		: DisplayObject		;	
			private		var pOverMc		: DisplayObject		;	
			private		var pDownMc		: DisplayObject		;
		/**
		* Constructor
		* @param	mc		Button container DisplayObject
		* @param	outMc	inner "out" DisplayObject
		* @param	overMc  inner "over" DisplayObject
		* @param	downMc  inner "down" DisplayObject
		*/	
		public function ButtonMng (mc:DisplayObject,outMc:DisplayObject=null,overMc:DisplayObject=null,downMc:DisplayObject=null,useHandCursor:Boolean=false) { 
			pMc = mc;
			
			if (pMc is Sprite && useHandCursor) Sprite(pMc).buttonMode = useHandCursor ;
			pOutMc=outMc;		
			pOverMc=overMc;		
			pDownMc = downMc;	
			if (pOverMc!=null) pOverMc.visible=false;
			if (pDownMc != null) pDownMc.visible = false;
			if (pOutMc!=null) pOutMc.visible=true;
			createEventListener();			
		}	
		
		private function createEventListener() {			
			pMc.addEventListener("rollOver",Delegate.pass(fChangeButton,pOverMc));
			pMc.addEventListener("rollOut",Delegate.pass(fChangeButton,pOutMc));		
			pMc.addEventListener("mouseDown",Delegate.pass(fChangeButton,pDownMc));
			pMc.addEventListener("click",Delegate.pass(fChangeButton,pOutMc));
		}
		private function fChangeButton(e:Event, mc:DisplayObject) {				
			if (pOutMc!=null) pOutMc.visible=false;
			if (pOverMc!=null) pOverMc.visible=false;
			if (pDownMc!=null) pDownMc.visible=false;
			mc.visible=true;
			
		}
	}
}

