﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/  
package net.flash_line.as3.util.ui {	 
	
	import flash.events.* ;
	import flash.display.DisplayObjectContainer ;
	import net.flash_line.as3.util.graph.ErrorGraph ;
	import net.flash_line.as3.util.graph.BasicButton ;
	import net.flash_line.as3.util.common.Super;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.motion.BasicTween;
	/**
	* Error frame manager. ErrorFrame use net.flash_line.as3.util.graph.ErrorGraph
	* @see net.flash_line.as3.util.graph.ErrorGraph
	*/
	public class  ErrorFrame  extends Super {
		private var pBt:BasicTween;
		private var pMc	: ErrorGraph ;			
		private var pDel	: Delay ;				
		/**
		* Create and error frame centered, at uppest depth and display message.
		* <p>Frame is drag and droppable, manual or auto-close</p>
		* @param	p			container
		* @param	msg			Message	string	
		* @param	w			width
		* @param	h			height
		* @param	autoClose	true if frame must be closed after 3 seconds. If false user must clic on close button.
		*/		
		public function ErrorFrame (p:DisplayObjectContainer,msg:String,w:Number=300,h:Number=200,autoClose:Boolean=true) { 
			var x:Number=(p.stage.stageWidth-w)/2;
			var y:Number=(p.stage.stageHeight-h)/2;
			pMc=new ErrorGraph(p,x,y,w,h);
			pMc.displayMsg(msg);
			var bb:BasicButton=pMc.closeMc;
			var bm:ButtonMng=new ButtonMng(bb.mc,bb.outMc,bb.overMc,bb.downMc);
			if (autoClose) {
				pDel=new Delay(3);
				pDel.addEventListener("onDelay",fClose);
			}
			createEvent();	
			setClassInfo("ErrorFrame",this);	
		}
		// get/set
		public function get text() {
			pMc.tf.text;
		}
		/**
		* Force remove of frame, listeners and Tween
		*/
		public function remove(quick:Boolean=false) {	
			pMc.removeEventListener(MouseEvent.MOUSE_DOWN,fOpenStartDrag);
			pMc.removeEventListener(MouseEvent.MOUSE_UP,fOpenStopDrag);
			if (pDel != null) pDel.removeEventListener("onDelay", fClose);
			if (quick) {
				pMc.remove();	
			} else {
				pBt=new BasicTween(pMc,"alpha",0);
				pBt.addEventListener("onEndTween", remove2);
			}
			return null;
		}
		//
		//
		//
		private function fClose(e:Event) {	
			remove();
		}		
		private function createEvent() {			
			pMc.closeMc.addEventListener("click",fClose);
			pMc.addEventListener(MouseEvent.MOUSE_DOWN,fOpenStartDrag);
			pMc.addEventListener(MouseEvent.MOUSE_UP,fOpenStopDrag);
		}		
		private function remove2(e:Event) {			
			pBt.removeEventListener("onEndTween",remove2);
			pMc.remove();	
			pBt.remove();
		}
		private function fOpenStartDrag(e:MouseEvent) {
			pMc.startDrag();
		}
		private function fOpenStopDrag(e:MouseEvent) {
			pMc.stopDrag();
		}
	}
}

