﻿/**
* error window manager -with external skin- 
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui {	
	import flash.events.* ;
	import flash.display.DisplayObjectContainer ;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.text.*;
	import net.flash_line.as3.util.motion.BasicTween;
	//
	public class  ErrorWin  extends Super {
				var pBt:BasicTween;;			
				var pDel			: Delay ;			
				var pCurrSpx		: SpriteX ;
				var pTf				: TextFieldX ;
				var pW				: Number;
				var pH				: Number;
				var pX				: Number;
				var pY				: Number;
				var pSkin			: SpriteX;
				var pCloseMc		: SpriteX
				var pCrossMc		: SpriteX
				var pBackMc			: SpriteX
				
				
		/**
		* constructor
		* @param	p			container parent
		* @param	skin		skin sprite - already loaded
		* @param	shiftX		the window will be centered + x shift 
		* @param	shiftY		the window will be centered + y shift 
		*/
		public function ErrorWin (p:SpriteX,skin:SpriteX,shiftX:Number=0,shiftY:Number=0) { 
			pParent=p;
			pW=skin.width;
			pH=skin.height;			
			pX=(p.stage.stageWidth-pW)/2+shiftX;
			pY=(p.stage.stageHeight-pH)/2+shiftY;
			
			//
			pSkin=skin;
			pSkin.visible=true;
			pCurrSpx=new SpriteX(p,pX,pY);
			pCurrSpx.addChildX(pSkin);			
			pCloseMc=pSkin.childX("bClose");
			pCrossMc=pSkin.childX("closeCross");
			pBackMc=pSkin.childX("back");
			pCurrSpx.visible=false;
			new ButtonMng2(pCloseMc);
			createEvent();
		}
		/**
		* display message
		* @param	msg message string 
		* @param 	noClose true means no automatic closing
		*/
		public function displayMsg(msg:String,noClose:Boolean=false) {			
			//
			removeEvent();
			//
			var spx:SpriteX=new SpriteX(pParent,pCurrSpx.x,pCurrSpx.y);
			//
			spx.addChildX(pSkin);
			pCurrSpx.remove();
			pCurrSpx=spx;
			//
			createEvent();
			
			//
			pTf.setText(msg,{align:"center"});
			//		
			if (noClose==false) {
				pDel=new Delay(3);
				pDel.addEventListener("onDelay",fClose);
			}
			//
			pCurrSpx.visible=true;	
			
			
			//
			
		}
		public function hide() {
			fClose(new Event("null"));
		}
		/**
		* Setting of text area
		* @param	tc			text color
		* @param	font		font name
		* @param	size 		font size	
		* @param	bold		true if bold
		*/
		public function setTextInfo(tc:Number=0x0,font:String=null,size=null,bold:Boolean=true) {
			font= getFont(font);
			size= getFontSize(size);	
			pTf	=	new	TextFieldX(pSkin,30,30,pW-60,pH-70,tc,font,size,bold,true);
			//pTf.multiline=true;pTf.wordWrap=true;
						
			
		}
		/**
		* 
		*/
		private function createEvent() {			
			pCloseMc.addEventListener("click",fClose);
			pCrossMc.addEventListener("click",fClose);
			pCurrSpx.addEventListener(MouseEvent.MOUSE_DOWN,fOpenStartDrag);
			pCurrSpx.addEventListener(MouseEvent.MOUSE_UP,fOpenStopDrag);
		}
		/**
		* 
		*/
		private function removeEvent() {			
			pCloseMc.removeEventListener("click",fClose);
			pCrossMc.removeEventListener("click",fClose);
			pCurrSpx.removeEventListener(MouseEvent.MOUSE_DOWN,fOpenStartDrag);
			pCurrSpx.removeEventListener(MouseEvent.MOUSE_UP,fOpenStopDrag);
		}
		// private
		private function fClose(e:Event) {	
			if (pDel!=null) pDel.removeEventListener("onDelay",fClose);
			pBt=new BasicTween(pCurrSpx,"alpha",0);
			pBt.addEventListener("onEndTween",fClose2);
		}
		private function fClose2(e:Event) {			
			pBt.removeEventListener("onEndTween",fClose2);
			pCurrSpx.visible=false;			
		}
		private function fOpenStartDrag(e:MouseEvent) {
			pCurrSpx.startDrag();
		}
		private function fOpenStopDrag(e:MouseEvent) {
			pCurrSpx.stopDrag();
		}
	}
}

