﻿/**
* Manage a group which have many NodeMng childs in an associate DOC -
* the DOC is this one of a NodeMng parent
* @see net.flash_line.as3.util.ui.NodeMng()
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui {	
	//
	import flash.display.* ;
	import flash.events.Event ;
	import net.flash_line.as3.util.event.EventX;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.ui.NodeMng;
	//	
	public class  NodeGroupMng  extends Super {
		var pSpx:DisplayObjectContainer;	
		var pCurrY:Number;
		var pNodeArr:ArrayX;
		var pH:Number;
		/**
		* constructor
		* @param	spx	Parent container 
		*/
		public function NodeGroupMng (spx:DisplayObjectContainer) { 
			pNodeArr=new ArrayX();
			pSpx=spx;pCurrY=0;
			setClassInfo("NodeGroupMng",this);
		}
		/**
		* 
		* @return actual visible height of this - in regard of open ou closed inner nodes
		*/
		public function get height ():Number {
			return pH;
		}
		/**
		* Add a new NodeMng
		* @param	nm
		*/
		public function addNode(nm:NodeMng) {			
			pNodeArr.push(nm);
			nm.addEventListener("onNodeResize",resizeNodeGroup);
			pSpx.addChild(nm.sp);
			nm.sp.x=0;nm.sp.y=pCurrY;
			pCurrY+=nm.head.height;
			pH=pCurrY;
		}
		/**
		* remove this and its children
		*/
		public function remove() {			
			var len=pNodeArr.length;
			for (var i:Number=0;i<len;i++) {
				var nm:NodeMng=pNodeArr[i] ;
				nm.removeEventListener("onNodeResize",resizeNodeGroup);	
				nm.remove();
			}
			
		}
		//
		// private classes
		//		
		private function resizeNodeGroup(e:EventX) {	
			var len=pNodeArr.length;
			pCurrY=0;
			for (var i:Number=0;i<len;i++) {
				var nm:NodeMng=pNodeArr[i] ;
				nm.sp.y=pCurrY;
				pCurrY+=nm.height;				
			}
			pH=pCurrY;
			dispatchEvt("onNodeGroupResize",{NodeGroupMng:this});
		}
	}
}

