﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui {		
	import flash.display.* ;
	import flash.events.*;
	import flash.ui.*;
	import net.flash_line.as3.util.ui.scroll.Lift;
	import net.flash_line.as3.util.graph.PopUpGraph;
	import net.flash_line.as3.util.text.*;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.event.*;
	/**
	* PopUpGraph manager.
	* 
	*/
	public class  PopUpMng  extends Super {
			protected		var pPopUp		: PopUpGraph	;
			protected 	var pTextContent : String ;	
			protected 	var pLiftMng : Lift ;
			protected	var _autoValidDelay : Delay2 ;
			
		/**
		* Constructor
		* @param	mc		Button container Sprite
		* @param	outMc	inner "out" sprite
		* @param	overMc  inner "over" sprite
		* @param	downMc  inner "down" sprite
		*/	
		public function PopUpMng (popUp:PopUpGraph) { 
			pPopUp=popUp;	
			createScrollMng();
			//showHideScroll(); at begining when popUp is opened, textField is often empty 
			storeFieldInstance();
			createEventListener();
			setClassInfo("PopUpMng",this);
		}	
		//get/set
		public function get autoValidDelay() :Delay2  {
			return _autoValidDelay;
		}
		public function set autoValidDelay(d :Delay2)  {
			_autoValidDelay = d;
			if (_autoValidDelay is Delay2) {
				if (!_autoValidDelay.hasEventListener(EventX.ON_DELAY)) {
					ael(_autoValidDelay, EventX.ON_DELAY, fAutoValidPopUp);
				} else {
					alert("From PopUpMng.autoValidDelay() : A timeout delay is already running !");
					alert("                      : Use PopUpMng.removeAutoValidDelay() before");
					
				}
			} else {
				alert("From PopUpMng.autoValidDelay() : Input var is not a Delay2 instance !");
			}
		}
		public function get popUp() :PopUpGraph  {
			return pPopUp;
		}
		public function get close() :SpriteX  {
			return pPopUp.close;
		}
		//
		public function get bClear() :SpriteX  {
			return pPopUp.bClear;
		}
		public function get cancel() :SpriteX  {
			return pPopUp.cancel;
		}
		public function get valid() :SpriteX  {
			return pPopUp.valid;
		}
		// inner scroll area
		public function get innerArea () :SpriteX  {
			return pPopUp.innerArea ;
		}		
		
		//
		public function get scrollable() :Boolean  {
			return  pPopUp.scrollable ;
		}	
		public function get scroll() :SpriteX  {
			return pPopUp.scroll;
		}		
		public function get scrollUp() :SpriteX  {
			return pPopUp.scrollUp;
		}		
		public function get scrollDown() :SpriteX  {
			return pPopUp.scrollDown;
		}
		public function get scrollButton() :SpriteX  {
			return pPopUp.scrollButton ;
		}
		public function get scrollGuide() :SpriteX  {
			return  pPopUp.scrollGuide;
		}
		public function get wheelArea() :SpriteX  {
			return  pPopUp.wheelArea;
		}
		
		// inner
		public function get tf() :TextFieldX  {
			return pPopUp.tf;
		}	
		public function get msk() :SpriteX  {
			return pPopUp.msk ;
		}		
		public function get container() :SpriteX  {
			return pPopUp.container ;
		}
		public function get textContent () :String {
			return pTextContent ;
		}
		public function set textContent (str:String)  {
			pTextContent=str ;
		}
		
		// model
		public function get popModel() :Object  {
			return pPopUp.popModel ;
		}
		// public
		public function remove() :* {
			removeScrollMng();
			if (close!=null) close.removeEventListener(MouseEvent.CLICK,fCancel);
			if (cancel!=null) cancel.removeEventListener(MouseEvent.CLICK,fCancel);
			if (valid!=null) valid.removeEventListener(MouseEvent.CLICK,fValid);
			if (bClear!=null) bClear.removeEventListener(MouseEvent.CLICK,fClear);
			if (tf!=null) tf.removeEventListener(Event.CHANGE ,fChangeText);
			if (tf!=null) tf.removeEventListener(MouseEvent.CLICK ,fClickOnText);
			popUp.removeEventListener(KeyboardEvent.KEY_DOWN,fEnterKey);
			for (var i:Number;i<stack.length;i++) {
				var field:*=stack[i].instance;				
				if (field is InputTextField) {
					field.removeEventListener(Event.CHANGE ,fChangeField);
				}
			}
			removeAutoValidDelay();
			return null;
		}
		public function closePopUp() {				
			popUp.remove();
		}
		public function closeAndRemove() {				
			closePopUp();			
			return remove();
		}
		public function getField(id:String) : * {	
			return stack.returnObjectOfId(id).instance ;			
		}
		public function getFieldArray() : ArrayX {	
			return stack ;
		}
		public function showHideScroll() {	
			if (scroll==null || innerArea==null) return;
			if (scrollable && container!=null) {	
				if (container.height>msk.height) scroll.visible=true;
				else  scroll.visible=false;
			} else   scroll.visible=false;
		}
		public function startScrolling () {	
			if (scrollable ) {					
				if (pLiftMng!=null) {
					showHideScroll();
					pLiftMng.resize();
				}
			} 
		}
		
		// protected
		protected function createScrollMng() {	
			if (scrollable) {				
				removeScrollMng();
				scroll.visible=true;
				pLiftMng=new Lift(container,wheelArea,scrollButton,scrollGuide,scrollUp,scrollDown);
			}
		}
		protected function removeScrollMng() {				
			if (pLiftMng!=null) pLiftMng.remove();
			if (scroll!=null) scroll.visible=false;
		}
		protected function createEventListener() {			
			if (close!=null) close.addEventListener(MouseEvent.CLICK,fCancel);
			if (cancel!=null) cancel.addEventListener(MouseEvent.CLICK,fCancel);
			if (valid!=null) valid.addEventListener(MouseEvent.CLICK,fValid);
			if (bClear!=null) bClear.addEventListener(MouseEvent.CLICK,fClear);
			if (tf!=null) tf.addEventListener(Event.CHANGE ,fChangeText);
			if (tf!=null) tf.addEventListener(MouseEvent.CLICK ,fClickOnText);
			popUp.addEventListener(KeyboardEvent.KEY_DOWN,fEnterKey);
			for (var i:Number=0;i<stack.length;i++) {
				var field:*=stack[i].instance;
				if (field is InputTextField) {
					field.addEventListener(Event.CHANGE ,fChangeField);
				}
			}
		}
		
		protected function fEnterKey(e:KeyboardEvent) {				
			// to be override. example :
			/*
			if(e.keyCode==Keyboard.ENTER) {
				doValid();
			}
			*/
		}
		protected function fClear(e:MouseEvent) {				
			doClear();
			showHideScroll();
		}
		protected function doClear() {				
			tf.setText("");
			textContent=tf.text;
			if (pLiftMng!=null) pLiftMng.reset();
			else container.y=0;
			//createScrollMng();
		}
		protected function fCancel(e:MouseEvent) {					
			dispatchEvt("onCancel",{instance:this});
			closeAndRemove();
		}
		protected function fValid(e:MouseEvent) {	
			doValid();
			
		}
		public function doValid() {				
			if (popUp.popModel.field!=null) {
				var arr:Array=popUp.popModel.field.item ;var len:Number=arr.length ;
				var fieldContent:Object={};
				for (var i:Number=0;i<len;i++) {
					var o:Object=arr[i]; 
					if (o.className!=null && o.instance!=null) {
						if (strVal(o.className)=="") var cn:String=strVal(popUp.popModel.field.className,"InputTextField") ; else cn=strVal(o.className,"InputTextField") ;
						if (cn=="InputTextField")  {
							fieldContent[o.id]=TextFieldX(o.instance).text;
						} else if (cn=="TextInput") {
						} else if (cn=="ComboBox") {
						} else if (cn=="TextArea") {
						} else if (cn=="RadioButton") {
						} else if (cn=="CheckBox") {				
						}
					}
				}
			}
			if (tf!=null) {
				textContent=tf.text;
			} else textContent=null;
			dispatchEvt("onValid",{instance:this,textContent:textContent,fieldContent:fieldContent});			
		}
		public function removeAutoValidDelay() {
			if (_autoValidDelay != null) {
				rel(_autoValidDelay, EventX.ON_DELAY, fAutoValidPopUp);
				_autoValidDelay = null;
			}
		}
		protected function fChangeText(e:Event) {				
			if (tf.text=="") doClear();
			if (pLiftMng!=null) pLiftMng.resize();
			showHideScroll();
		}
		protected function fChangeField(e:Event) {			
			dispatchEvt("onChangeField",{field:e.currentTarget,instance:this});
		}
		protected function fClickOnText(e:MouseEvent) {				
			dispatchEvt("onWantToChangeText");
		}
		
		
		protected function storeFieldInstance() {	
			stack=new ArrayX();
			if (popUp.popModel.field!=null) stack.copyInto(popUp.popModel.field.item);
			
		}
		protected function fAutoValidPopUp(ex:EventX) {
			removeAutoValidDelay();
			doValid();
		}
		
		
	}
}































