﻿/**
* Manage a  tree - 
* @see NodeMng et NodeGroup classes in same package
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui {	
	//
	import flash.display.* ;
	import flash.events.Event ;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.ui.NodeMng;
	import net.flash_line.as3.util.ui.NodeGroupMng;
	import net.flash_line.as3.util.graph.*;
	import fl.controls.*;
	//	
	public class  TreeMng  extends Super {
		var pSpx:SpriteX;	// container
		var pTree: TreeObject ; // Tree Model // Object ; //
		var pEntry:String ; // root entry name
		var pCurr:Object;
		/**
		* constructor
		* @param	spx	Parent container 
		*/
		public function TreeMng (treeObj:Object,entry:String,spx:SpriteX) { 			
			/**
			* WARNING
			* IF BUGS or to TEST with alert() :
			* replace next line by
			* 
			*     pTree = treeObj ; 
			* 
			* AND
			* var pTree:TreeObject ;
			* BY
			* var pTree:Object ;
			*/
			pTree=new TreeObject(treeObj);	
			pSpx=spx;
			pEntry=entry;			
			setClassInfo("TreeMng",this);
		}
		// get/set
		/**
		* visible node width
		*/
		public function get width () {
			return Number(pTree[pEntry].width) ;
		}
		/**
		* largest width -mask width- to include subtrees
		*/
		public function get globalWidth () {
			return Number(pTree[pEntry].globalWidth) ;
		}
		/**
		* node or element head height - not include body where are subtrees
		*/
		public function get height () {
			return Number(pTree[pEntry].height) ;
		}
		/**
		* text fontsize
		*/
		public function get fontSize () {
			return Number(pTree[pEntry].fontSize) ;
		}
		/**
		* Build and display the visible tree
		*/
		public function build () { 
			create(pTree[pEntry]);
		}
		/**
		* create the tree
		* @param	o 	Main object which describe tree
		* @param	nm  parent NodeMng - this method is recursive, first time nm=null -
		*/
		private function create (o:Object,nm:NodeMng=null) { 				
			var nm:NodeMng;
			var nm2:NodeMng;
			var ngm:NodeGroupMng;
			var i:String;
			if (nm==null) nm=createEmptyNode(o)	;
			for (i in o.children) {				
				if (o.children[i].type=="node") {
					if (ngm==null) ngm=nm.createNodeGroup();
					nm2=createEmptyNode(o.children[i]);
					ngm.addNode(nm2);				
					create(pTree[i],nm2);
				} else {	
					var bb:BasicButton=createElem(o.children[i]);
					nm.addElem(bb);	
				}
				dispatchEvt("onCreateRow",{subTreeObject:o.children[i].eventObject} );
			}
		}
		//
		//private methods
		//
		private function createEmptyNode(o:Object) {			
			var ng:NodeGraph=new NodeGraph(pSpx,0,0,width,globalWidth,height,fontSize);
			ng.setLabel(o.label);
			var nm:NodeMng=new NodeMng(ng.opener,ng.head,ng.msk,ng.container);
			nm.addEventListener("onNodeClick",Delegate.pass(fOnNodeClick,o));
			return nm ;
		}
		private function createElem(o:Object) {
			var bb:BasicButton=new BasicButton(pSpx,0,0,width,height,0xddddff,.35);
			bb.addEventListener("click",Delegate.pass(fOnElemClick,o));
			bb.setLabel(o.label,0,null,fontSize);
			return bb ;
		}
		private function fOnNodeClick(e:EventX,o:Object) {
			dispatchEvt("onNodeClick",{subTreeObject:o.eventObject});
		}
		private function fOnElemClick(e:Event,o:Object) {
			dispatchEvt("onElemClick",{subTreeObject:o.eventObject});
		}
		
		
	}
}

		