﻿/**
* TreeObject is used as tree and subtree in TreeMng class.
* the parent global Object has one root entry -TreeObject-
* this entry have one children Object which contains many children TreeObject
* each child  has also an entry in global parent object with inside ist own children ...An so on
* until elem childs Objects which have'nt any entry in the global parent object and so have'nt children object.
* 
* Sample :
*
// - global parent Object
{
  // - root :

 .racine=   {
    .fontSize=10
    .height=18
    .width=200
    .label=Label VISION INVEST 2008
    .globalWidth=600
    .type=root
    .children=      {
       .qualite=         {
          .label=Qualité du programme immobilier
          .type=node
          .openable=true
        }
    }
   
 }

 // node subtree  :

 .qualite=   {
    .label=Qualité du programme immobilier
    .children=      {
       .service=         {
          .label=Commerces de services
          .type=elem
          .openable=false
         }
       .alimentation=         {
          .label=Commerces d'alimentation
          .type=elem
          .openable=false
        }
    }
  }
}
*
* 
* To do simple : input global parent object and All its objects become TreeObject
* but only object inside the .children object have really the properties 
* listed below in get functions.
* NB : 
* 	TreeObject is dynamic as native Object class  - other properties may exist without generate problem when TreeMng class use TreeObject.
* 	TreeObject is above all used by programer to memorize used properties 
* 
* 
* @see TreeMng() in same package
* 
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 


	//
package net.flash_line.as3.util.ui {	
	//
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	//	
	dynamic public class  TreeObject  extends Object {
		public var _width:Number;			// used only in type "root" node
		public var _globalWidth:Number;		// used only in type "root" node
		public var _height:Number;			// used only in type "root" node
		public var _fontSize:Number;		// used only in type "root" node
		public var _label:String;
		public var _type:String;
		public var _children:Object;
		public var _openable:Boolean;		// used only in type "root" or "node" node
		public var _eventObject:Object;		// subtree -similar to this- which will be sent with "onNodeClick" or "onElemClick" events of TreeMng
		/**
		* constructor
		* @param o Source Object to buid TreeObject
		*/
		public function TreeObject (o:Object,tab:String="") { 
			for (var i:String in o) {
				if (isObjSet(o[i])) {
					tab+="  ";
					this[i]=new TreeObject(o[i],tab);
					if (i!="children") {
						this[i].eventObject=o[i];
					}
				} else {
					this[i]=o[i] ;
				}
			}
		}
		// get/set
		/**
		* subtree -similar to this- which will be sent with "onNodeClick" or "onElemClick" events of TreeMng
		*/
		public function get eventObject () : Object {
			return _eventObject ;
		}
		public function set eventObject (o:Object)  {			
			_eventObject=o ;
		}
		/**
		* visible node/elem head width
		*/
		public function get width () : Number {
			return Number(_width) ;
		}
		public function set width (n:*)  {
			if (isNaN(n)) {
				alert("TreeObject : width is invalid !");
			}
			_width=Number(n) ;
		}
		/**
		* largest width -mask width- so large to include many cascaded subtrees
		*/
		public function get globalWidth () : Number {
			return Number(_globalWidth) ;
		}
		public function set globalWidth (n:*)  {
			if (isNaN(n)) {
				alert("TreeObject : globalWidth is invalid !");
			}
			_globalWidth=Number(n) ;
		}
		/**
		* node or element head height - not include body which contains subtrees
		*/
		public function get height () :Number {
			return Number(_height) ;
		}
		public function set height (n:*)  {
			if (isNaN(n)) {
				alert("TreeObject : height is invalid !");
			}
			_height=Number(n);
		}
		
		/**
		* text fontsize
		*/
		public function get fontSize () :Number {
			return Number(_fontSize) ;
		}
		public function set fontSize (n:*)  {
			if (isNaN(n)) {
				alert("TreeObject : fontSize is invalid !");
			}
			_fontSize=Number(n) ;
		}
		
		/**
		* 
		* @return visible label - head's label
		*/
		public function get label () : String {
			return _label;
		}
		public function set label (s:String)  {
			_label=s ;
		}
		
		/**
		* 
		* @return "node" or "elem" or "root"
		* 			"node" type has children property - elem not
		* 			"root" is like node but it's the entry node
		*/
		public function get type () : String {			
			return _type.toLowerCase() ;
		}
		public function set type (s:String)  {
			_type=s.toLowerCase() ;
		}
		/**
		* 
		* @return the list -object- of children objects
		*/
		public function get children () : Object {
			return _children ;
		}
		public function set children (o:Object)  {
			_children=o ;
		}
		/**
		* 
		* @return true if the node is to be opened
		*/
		public function get openable () : Boolean {
			return _openable ;
		}
		public function set openable (b:*)  {
			if (b is String) _openable=(b=="true");
			else _openable=b;
		}
		
		
	}
}

		