﻿/**
* @author Jean-Michel Delettre © (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.bubble {
	import flash.display.* ;
	import flash.text.*;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.text.TextFieldX;
	import net.flash_line.as3.util.graph.*;
	import net.flash_line.as3.util.motion.BasicTween ;
	/**
	* Manage info bubble with fixed location and down effect .
	* @see BubbleInfo
	*/ 	    
    public class  BubbleInfoFixed  extends BubbleInfo {
	
		/**
		* Constructor
		* @param	ctnr			 Container where the info sprite will be created
		* @param	vMc				 source of rollOver event 
		* @param	vTxt			 associate text
		* @param	vX				 pos x 
		* @param	vY				 pos y
		* @param	vW				 width
		* @param	vH				 height
		* @param	vDelay			 RollOver delay in second 
		* @param	vDelayTween		 Tween delay in second
		* @param	vAlpha			 backGround alpha
		*/
		public function BubbleInfoFixed		  ( ctnr		:DisplayObjectContainer ,
											vMc			:DisplayObject	,
											vTxt		:String		,	
											vX			:Number			=0,
											vY			:Number 		=0,
											vW			:Number			=150,
											vH			:Number			=34,
											vDelay		:Number			=1.2,
											vDelayTween :Number			=.5,
											vAlpha		:Number			=.55		
										) {		
			super(ctnr,vMc,vTxt,vX,vY,vW,vH,vDelay,vDelayTween,vAlpha);
			setClassInfo("BubbleInfoFixed",this);	
		}
		// set & get
		
		/**
		* info-bubble frame background
		*/
		public function get bg() :SpriteX {
			return target.getSpx("bg");
		}
		/**
		*  info-bubble frame transparent layer
		*/
		public function get layer() :SpriteX {
			return target.getSpx("layer");
		}
		/**
		* Line at the bottom of background
		*/
		public function get line() :SpriteX {
			return target.getSpx("line");
		}
		//
		//
		/**
		* Display bubble info
		* @param	vX	pos x
		* @param	vY	pos y
		*/
		override public function display(vX:Number=NaN,vY:Number=NaN) {			
			if (pTxt == null || pTxt == "") pTxt = "No info/Pas d'info !";
			if (isNaN(vX)) vX=pX; 
			if (isNaN(vY)) vY=pY;
			var ctnr:DisplayObjectContainer=pCtnr;
			pTarget = new SpriteX(ctnr,vX,vY,1,"target"); 
			var w:Number=pW;
			new RectFill  ( pTarget,0,0,w,pH,0x0,pAlpha,"bg");
			new RectFill  ( pTarget,0,0,w,pH,0x0,.2,"layer");			
			new Hline	  ( pTarget,0,0,w,0xffffff,0x0,.15,"line");			
			var d=pDelayTween; var e=pH ; layer.height=0; bg.height=0;
			new BasicTween(layer,"height",e,d);
			line.y=0;
			new BasicTween(line,"y",e,d);
			//text
			displayText();
			pTxtFld.alpha=0; e=1;
			new BasicTween(pTxtFld,"alpha",e,d*1.5);
			//
			new Delay2(pDelayTween*.5).addEventListener("onDelay",fDisplay2);				
		}		
		/**
		* @private
		 * Display text in bubble
		 * @return text width
		 */
		 override public  function displayText() : Number {
			removeText();
			pTxtFld = new TextFieldX  (pTarget,5,2,pW,pH,0xc4c4c4,getFont(),10,true,true);
			pTxtFld.setText(pTxt);	
			return pTxtFld.textWidth*1.03;
		}	
		//
		//
		//
		private function fDisplay2(ex:EventX) {			
			var d = pDelayTween * .75; var e = pH ; 
			if (bg!=null) {
				new BasicTween(bg,"height",e,d);
				new Delay2(d).addEventListener("onDelay", fDisplay3);
			}
		}
		private function fDisplay3(ex:EventX) {	
			dispatchEvt("onDisplayBubble",{target:pTarget});	
		}
		 //------Private method ------ 
		/// 
		
		
	}
}