﻿/**
* Manage a  standard top menu - 
* @see MenuH and MenuV classes in same package
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.menu {	
	//
	import flash.display.* ;
	//import flash.events.Event ;
	import net.flash_line.as3.util.event.*; 
	import net.flash_line.as3.util.common.SpriteX;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.xml.XmlParser;
	import net.flash_line.as3.util.text.TextFieldX;
	//	
	public class  Menu  extends SpriteX {
		var pId:String;
		var pMenu:Object;
		var pFont:String;
		var pFontSize:Number;
		var pVopen:Boolean;
		//var pSave:Array;
		public function Menu (ctnr:DisplayObjectContainer=null,n:String=null,id:String="mainMenu") { 				
			super(ctnr,0,0,1,n);
			pId=id;
			setClassInfo("Menu",this);
			pVopen=false;
		}
		// get/set
		public function get font ():String {
			return pFont;
		}
		public function get fontSize ():Number {
			return pFontSize;
		}
		public function set font (s:String) {
			pFont=s;
		}
		public function set fontSize (n:*) {
			pFontSize=N(n);
		}
		public function get menuObj ():Object {
			return pMenu;
		}
		//
		
		
		//
		public function load (file:String, base:String="") {
			var xlp= new XmlParser(base+file);	
			xlp.addEventListener("onParseXml",fOnParseXml);
			xlp.addEventListener("onErrorXml",fOnErrorXml);
			xlp.loadXml();
		}
		public function create (menuObj:Object) { 				
			if (pMenu==null) pMenu=menuObj;
			createTitle();
			x = pMenu.x ; y = pMenu.y; var tab:Number = N(pMenu.children.tab) ; var vTab:Number = N(pMenu.children.vTab) ; var vColor:Number = N(pMenu.children.vColor) ;
			var vSpace:Number = numVal(pMenu.children.vSpace, 0);
			pMenu.menuH=new MenuH(this,pMenu.children,font,fontSize);
			var arr:Array=pMenu.children.elem ; var len:Number=arr.length;			
			for (var i=0;i<len;i++) {
				arr[i].elemSpx.addEventListener("onClick",fOnHelemClick);
				arr[i].elemSpx.addEventListener("onOver", fOnHelemOver);
				// V menus
				if (arr[i].children!=null) {
					var spx:SpriteX=new MenuV(this,arr[i].children,font,fontSize,tab,vColor,vSpace,arr[i].id );
					arr[i].menuV=spx;
					spx.x=arr[i].elemSpx.x ;spx.y=pMenu.menuH.height+vTab;
					spx.addEventListener("onClick", fOnVelemClick);
				}
			}
			// init - first refresh
			refresh();
		}
		public function disable (inArr:Array) :Boolean { 
			if (!isArrSet(inArr)) return false ;
			stack.push(inArr);
			var arr:Array=pMenu.children.elem ; var len:Number=arr.length;
			for (var i=0;i<len;i++) {
				arr[i].menuV.disable(inArr);
			}
			return true ;
		}
		public function popDisable () :Array { 
			return stack.pop();
		}		
		public function restoreDisable () :Boolean { 
			if (popDisable () !=null) {
				var inArr:Array=popDisable () ;
				if (inArr!=null) return disable (inArr);
				else return false;
			}
			return false ;
		}
		/*
		public function save()  { 
			pSave=popDisable ();// Array(stack.last).slice();
		}
		public function restoreFromSaved ()  { 
			disable(pSave);
		}*/
		public function addAsDisable (inArr:Array) :Array  { 
			var arr:Array;
			arr=inArr.concat(popDisable ());
			disable (arr);
			return arr;
		}
		public function addAsEnable (inArr:Array) :Array  { 
			var arr:Array;		
			arr=popDisable ();
			if (arr!=null) {
				for (var i:Number=0;i<inArr.length;i++) {	
					for (var j=0;j<arr.length;j++) {
						if (arr[j]==inArr[i]) {
							arr.splice(j,1);
							break;
						}
						
					}
				}
				disable (arr);
			}
			return arr;
		}
		
		public function close () {
			pVopen=false;
			refresh();
		}
		
		//private methods
		//
		private function createTitle () {		
			if (strVal(pMenu.label,"") != "") {
				var tf:TextFieldX;var shiftY=-35;var h=30; var w=500;
				tf=new TextFieldX(this,0,shiftY,w,h,pMenu.textColor,getFont(),20,true,true) ;	
				tf.setText(pMenu.label ) ;
			}
		}
		
		private function fOnParseXml (e:EventX) {
			
			if (e.srcVar.tree!=null ) {
				font=e.srcVar.tree.menu.font ;
				fontSize=N(e.srcVar.tree.menu.fontSize) ;
				pMenu=e.srcVar.tree.menu[pId] ; 			
				create(pMenu);	
				dispatchEvt("onCreate", { tree:pMenu } );
			} else {
				error("Menu Xml file is invalid !");
			}
			
		}
		private function fOnErrorXml (e:EventX) {
			error("menu Xml file not found !");
		}
		
		private function fOnHelemClick (ex:EventX) { 			
			var o:Object = ex.srcVar.obj;
			if (o.children != null) {
				// there is vertical menu
				pVopen=!pVopen;			
				var arr:Array=pMenu.children.elem ; var len:Number=arr.length;
				for (var i=0;i<len;i++) {
					arr[i].vOpen=false;
				}
				o.vOpen=true;
				refresh();
			} else {
				// horizontal elem only -vertical less
				dispatchEvt("onClick",{obj:o});
				
			}
			
		}
		private function fOnHelemOver (ex:EventX) { 			
			var o:Object=ex.srcVar.obj;
			var arr:Array=pMenu.children.elem ; var len:Number=arr.length;
			for (var i=0;i<len;i++) {
				arr[i].vOpen=false;
			}
			o.vOpen=true;
			refresh();
		}
		private function refresh () { 
			var arr:Array=pMenu.children.elem ; var len:Number=arr.length;
			for (var i=0;i<len;i++) {
				if (arr[i].menuV!=null) arr[i].menuV.visible=(arr[i].vOpen && pVopen);				
			}
		}
		private function fOnVelemClick (ex:EventX) { 			
			var o:Object=ex.srcVar.obj;
			dispatchEvt("onClick",{obj:o});
		}
		
	}
}

		