﻿/**
* Super class of standard menu element ( interactive label)- 
* @see MenuH_Elem and MenuV_elem classes in same package
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.menu {	
	//
	//import flash.display.* ;
	import flash.display.DisplayObject;
	import flash.events.* ;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.common.SpriteX;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.graph.*;
	import net.flash_line.as3.util.text.TextFieldX;
	//	
	public class  MenuElem  extends SpriteX {
		var pLabel:String;
		var pShortCut:String;
		var pObj:Object;
		var pFont:String;
		var pFontSize:Number;
		var pTfx:TextFieldX;		
		var pColor:Number;
		var pActiv:SpriteX;
		var pSkinSpx:SpriteX;
		var pOverSpx:SpriteX;
		var pAlign:String;
		var pWidth:Number;
		public function MenuElem (ctnr:SpriteX,o:Object,font:String,fontSize:Number,c:Number=0) { 			
			super(ctnr);
			pFont=font;
			pFontSize=fontSize;
			color=c;
			pObj=o;			
			setClassInfo("MenuElem",this);
			
		}
		// get/set		
		public function set addInSkin(sp:DisplayObject)  {
			pSkinSpx.addChildX(sp);
		}
		public function set addInOver(sp:DisplayObject)  {
			pOverSpx.addChildX(sp);
		}
		public function get skin() :SpriteX {
			return pSkinSpx ;
		}
		public function get overSkin() :SpriteX {
			return pOverSpx ;
		}
		//
		public function get font ():String {
			return pFont;
		}
		public function get fontSize ():Number {
			return pFontSize;
		}
		public function get color ():Number {
			return pColor;
		}
		public function set font (s:String) {
			pFont=s;
		}
		public function set fontSize (n:*) {
			pFontSize=N(n);
		}
		public function set color (n:*) {
			pColor=N(n);
		}
		//
		
		
		public function create (o:Object) { 				
			
		}
		public function createEvent () { 				
			pActiv.addEventListener(MouseEvent.ROLL_OVER ,fOnOver);
			pActiv.addEventListener(MouseEvent.ROLL_OUT ,fOnOut);
			pActiv.addEventListener(MouseEvent.CLICK ,fOnClick);
		}
		public function removeEvent () { 				
			pActiv.removeEventListener(MouseEvent.ROLL_OVER ,fOnOver);
			pActiv.removeEventListener(MouseEvent.ROLL_OUT ,fOnOut);
			pActiv.removeEventListener(MouseEvent.CLICK ,fOnClick);
		}
		//
		//private methods
		//
		private function fOnOver (e:MouseEvent) { 	
			if (pOverSpx!=null) pOverSpx.visible = true;
			// specific visio geslab : pActiv.alpha=.05;
			dispatchEvt("onOver",{obj:pObj});
			
		}
		private function fOnOut (e:MouseEvent) { 				
			// specific visio geslab : pActiv.alpha=0;
			if (pOverSpx!=null) pOverSpx.visible = false;
			dispatchEvt("onOut",{obj:pObj});
		}
		private function fOnClick (e:MouseEvent) { 				
			// specific visio geslab : pActiv.alpha = 0;
			if (pOverSpx!=null) pOverSpx.visible = true;
			dispatchEvt("onClick",{obj:pObj});
		}
		
		
		
	}
}

		