﻿/**
* Manage a  standard vertical menu - 
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.menu {	
	//
	//import flash.display.* ;
	//import flash.events.Event ;
	import net.flash_line.as3.util.event.*;
	import net.flash_line.as3.util.common.SpriteX;
	import net.flash_line.as3.util.global.*;
	//	
	public class  MenuV  extends SpriteX {
		var pArr:Array;
		var pFont:String;
		var pFontSize:Number;
		var pTabu:Number;
		var pSkinSpx:SpriteX;
		var pArrowSkinSpx:SpriteX;
		var pBackHeight:Number;
		var pColor:Number;
		var pVSpace:Number;
		var pAlign:String;
		var pWidth:Number;
		var pPaddingTop:Number;
		var pParentId:String;
		public function MenuV (ctnr:Menu,o:Object,font:String,fontSize:Number,tabu:Number,c:Number=0,vSpace:Number=0,parentId:String=null) { 			
			super(ctnr);
			pFont=font;
			pFontSize = fontSize;
			pAlign = strVal(o.align, "left");
			pWidth = numVal(o.width, 30 );
			pPaddingTop = numVal(o.vPaddingTop, 0);
			pArr=o.elem;
			pTabu=Number(tabu);
			pColor=Number(c);
			pVSpace = Number(vSpace);
			pParentId = parentId;
			setClassInfo("MenuV",this);
			create(pArr); 
		}
		// get/set		
		public function set addInSkin(spx:SpriteX)  {
			pSkinSpx.addChildX(spx);
		}
		public function get skin() :SpriteX {
			return pSkinSpx ;
		}
		public function set addInArrowSkin(spx:SpriteX)  {
			pArrowSkinSpx.addChildX(spx);
		}
		public function get arrowSkin() :SpriteX {
			return pArrowSkinSpx ;
		}
		//
		public function get font ():String {
			return pFont;
		}
		public function get fontSize ():Number {
			return pFontSize;
		}
		public function set font (s:String) {
			pFont=s;
		}
		public function set fontSize (n:*) {
			pFontSize=N(n);
		}
		//
		public function get backHeight ():Number {
			return pBackHeight;
		}
		//
		
		public function create (arr:Array) { 				
			if (pArr==null) pArr=arr;			
			var len:Number=pArr.length;
			var currY:Number=0;
			// create empty back skin
			pSkinSpx=new SpriteX(this,0,0,1);
			//
			for (var i=0;i<len;i++) {
				var o:Object = pArr[i];		
				var spx:SpriteX=new MenuV_elem(this,o,font,fontSize,pColor,pAlign,pWidth,pPaddingTop);				
				o.elemSpx = spx;
				o.parentId = pParentId;
				spx.x=pTabu ; spx.y=currY;
				currY+=spx.height+pVSpace;
				//create event
				o.elemSpx.addEventListener("onClick",fOnElemClick);
				o.elemSpx.addEventListener("onOver",fOnElemOver);
			}
			// create empty arrow skin
			pArrowSkinSpx=new SpriteX(this,0,0,1);
			//************************************
			pBackHeight=currY;
		}
		public function disable (inArr:Array) { 			
			var len:Number=pArr.length;
			for (var i=0;i<len;i++) {				
				if (isToBeDisable(pArr[i].id,inArr) ) pArr[i].disable=true;
				else pArr[i].disable=false;
			}
			refresh();
		}
		public function isToBeDisable (id:String,inArr:Array) { 			
			var len:Number=inArr.length;
			if (len>0 && inArr[0].toLowerCase()=="all" ) return true ;
			if (len>0 && inArr[0].toLowerCase()=="none" )return false ;
			for (var i=0;i<len;i++) {				
				if (inArr[i].toLowerCase()==id.toLowerCase()) return true;
			}
			return false;
		}
		//
		//private methods
		//
		private function fOnElemClick (ex:EventX) { 				
			var o:Object=ex.srcVar.obj;
			var len:Number=pArr.length;
			for (var i=0;i<len;i++) {
				pArr[i].clickSelect=false;
			}
			o.clickSelect=true;
			dispatchEvt("onClick",{obj:o});
		}
		private function fOnElemOver (ex:EventX) { 			
			var o:Object=ex.srcVar.obj;
			var len:Number=pArr.length;
			for (var i=0;i<len;i++) {
				pArr[i].overSelect=false;
			}
			o.overSelect=true;
			refresh();
		}
		private function refresh () { 
			var len:Number=pArr.length;
			var allAreDisable:Boolean=true;
			for (var i=0;i<len;i++) {
				var o:Object=pArr[i];
				if (o.overSelect) arrowSkin.y=o.elemSpx.y+o.elemSpx.height/4;
				if (o.disable) 	o.elemSpx.disable();
				else 			{
					o.elemSpx.enable();
					allAreDisable=false;
				}
			}
			arrowSkin.visible=(!allAreDisable)
		}
		
		
	}
}

		