﻿/**
* Scroll manager with 2 top and botton buttons
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.scroll {		
	import flash.display.* ;
	import flash.events.* ;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.motion.BasicTween;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.event.*;
	//
	public class HPressScroll extends Super {
		private 	var pMc			: Sprite		; 	//scrolled mc
		private 	var pOx			: Number		; 	// mc origine position
		private 	var pPos		: Number		; 	// mc current position
		private		var pRight		: Sprite		;	//right button mc
		private		var pLeft		: Sprite		;	//left
		private		var pMsk		: Sprite		;	//Mask mc
		private		var pMarge		: Number		;	//marge 
		private		var pStep		: Number		;	// movement lenght
		private		var pDur		: Number		;	// tween duration
		
		
					
		// Constructor
		public function HPressScroll	( vMc:Sprite,vLeft:Sprite,vRight:Sprite,vMsk:Sprite,step:Number=200,d:Number=1) {		
			setClassInfo("HPressScroll",this);
			pMc=vMc;
			pOx=pMc.x;
			pPos=pOx;
			pLeft=vLeft;
			pRight=vRight;
			pMsk=vMsk;	
			pStep=step;
			pDur=d;				
		}
		public function get pos () :Number {	
			return pPos;
		}
		public function move(sens:Number=1,pos=null) {				
			var e:Number;
			e=pMc.x+pStep*sens;
			if(pos!=null) e=pos;
			disableRight();
			disableLeft();
			if (sens>0) {
				if (e>=pOx) e=pOx;
				else enableLeft();	
				enableRight();	
			} else {
				if (e<pOx-pMc.width+pMsk.width) e=pOx-pMc.width+pMsk.width;
				else enableRight();
				enableLeft();
			}
			pPos=e;
			clearTween();
			stack.push(new BasicTween(pMc,"x",e,pDur));				
		}
		public function clearTween() {				
			stack.remove();
		}		
		public function remove() {
			disableRight();
			disableLeft()
			clearTween();
			pMc.x=pOx;
		}
		public function enableRight() {
			pRight.addEventListener(MouseEvent.CLICK,fRight);
			dispatchEvt("onChange",{state:"onEnableRight"});
		}
		public function disableRight() {
			pRight.removeEventListener(MouseEvent.CLICK,fRight);
			dispatchEvt("onChange",{state:"onDisableRight"});
		}
		public function enableLeft() {
			pLeft.addEventListener(MouseEvent.CLICK,fLeft);	
			dispatchEvt("onChange",{state:"onEnableLeft"});
		}
		public function disableLeft() {
			pLeft.removeEventListener(MouseEvent.CLICK,fLeft);	
			dispatchEvt("onChange",{state:"onDisableLeft"});
		}
			

		// Private Methods
		
		private function fLeft(e:MouseEvent) {
			move(1);
			dispatchEvt("onMove");
		}
		private function fRight(e:MouseEvent) {
			move(-1);
			dispatchEvt("onMove");
		}
		
	}
}