﻿/**
* Scroll manager with 2 top and botton buttons
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.ui.scroll {		
	import flash.display.* ;
	import flash.events.* ;
	import net.flash_line.as3.util.common.*;
	import net.flash_line.as3.util.global.*;
	import net.flash_line.as3.util.event.*;
	//
	public class ScrollFrame extends Super {
		private 	var pMc			: Sprite		; 	//scrolled mc
		private 	var pOy			: Number		; 	// mc origine _y
		private		var pDown		: Sprite		;	//down button mc
		private		var pUp			: Sprite		;	//Up 
		private		var pMsk		: Sprite		;	//Mask mc
		private		var pMargeUp	: Number		;	//marge up 
		private		var pClk		: Clock			;	//
		private		var pSens		: Number		;	// = 1 if down ; -1 if up
		private		var pAccel		: Number		;	// 
		private		var pSpeed		: Number		;	
					
		// Constructor
		public function ScrollFrame	( vMc:Sprite,vUp:Sprite,vDown:Sprite,vMsk:Sprite,vMargeUp=null) {		
			setClassInfo("ScrollFrame",this);
			pMc=vMc;
			pOy=pMc.y;
			pUp=vUp;
			pDown=vDown;
			pMsk=vMsk;
			if (vMargeUp==null) pMargeUp = pMsk.height ;
			else pMargeUp=Number(vMargeUp) ;		
			createEvent();				
		}
		
		public function setPos(vY:Number) {
			pMc.y=vY;
		}
		public function enable() {
			pSpeed=4;pAccel=1.1;
			pClk=new Clock(onClock);
		}
		public function disable() {			
			if (pClk!=null) pClk=pClk.remove();
		}
		public function onClock(e:TimerEvent) {	
			move();
		}
		public function move() {
			pMc.y+=((pSpeed)*pSens) ;
			if (pMc.y<pMsk.y-pMc.height+pMargeUp) {
				pMc.y=pMsk.y-pMc.height+pMargeUp;
			}
			if (pMc.y>pMsk.y) {
				pMc.y=pMsk.y ;
			}
			pSpeed=pSpeed*pAccel;
		}
		public function createEvent() {
			pUp.addEventListener(MouseEvent.MOUSE_DOWN,fUp);
			pUp.addEventListener(MouseEvent.MOUSE_UP,fOut);
			pDown.addEventListener(MouseEvent.MOUSE_DOWN,fDown);
			pDown.addEventListener(MouseEvent.MOUSE_UP,fOut);			
			pUp.alpha=1;		
			pDown.alpha=1;
			createWheelEvent();
		}
		public function disableEvent() {		
			pUp.removeEventListener(MouseEvent.MOUSE_DOWN,fUp);
			pUp.removeEventListener(MouseEvent.MOUSE_UP,fOut);
			pDown.removeEventListener(MouseEvent.MOUSE_DOWN,fDown);
			pDown.removeEventListener(MouseEvent.MOUSE_UP,fOut);		
			pUp.alpha=.3;		
			pDown.alpha=.3;
			disableWheel();
		}
		public function remove() {
			disable();
			disableEvent();
			pMc.y=pOy;
		}
		public function gray() {
			pMc.alpha*=.50;
		}
		public function highLight() {
			pMc.alpha=1;
		}

		// Private Methods
		private function createWheelEvent () {
			//TODO EM.addEventListener(this,Mouse,"wheelFocusIsOnMe",disableWheel); use with who var
			enableWheel();
		}
		private function enableWheel () {
			//TODO EM.broadcastMessage(Mouse,"wheelFocusIsOnMe",this);			
			pMc.addEventListener(MouseEvent.MOUSE_WHEEL,doWheel);
		}
		private function disableWheel(who:Object=null) {
			if (who==null) who={};
			if (who!=this) pMc.removeEventListener(MouseEvent.MOUSE_WHEEL,doWheel);
		}	
		private function doWheel (e:MouseEvent) {
			var step:int=e.delta;
			pSpeed=12;pAccel=1;
			if (step>0) {
				pSens=1;move();
			} else if (step<0) {
				pSens=-1;move();
			} 
		}
		private function fUp(e:MouseEvent) {	
			enable();
			pSens=1;
		}
		private function fDown(e:MouseEvent) {
			enable();
			pSens=-1 ;
		}
		private function fOut(e:MouseEvent) {
			disable();
		}
	}
}