﻿/**
* Model of XmlParser 
* @see XmlParser
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/

//
package net.flash_line.as3.util.xml {
	import net.flash_line.as3.util.xml.Node ;
	import net.flash_line.as3.util.common.* ; 
	import net.flash_line.as3.util.global.* ;
	import net.flash_line.as3.util.event.* ;
	
	class Model extends Super {
		var pDel:Delay;				// used to delay when big parsing
		var pFunc:Function;			// used to delay when big parsing
/**
* constructor
*/
		public function Model() {
			setClassInfo("Model",this);
		}

/**
* 
* @param	n	Xml Node 
* @param	o	Object of Object and/or Array
* @param	tab spaces -it is recursively built by Model.toObject() 
*/		
		public function toObject(n:Node,o:Object,tab:String=null) {			
			if (tab==null) tab="";
			tab=tab+"     ";
			//			
			if (n._hasArray) {
				var arr2:Array=n.addArrayIn(o) ;
			} else if (n._hasObject) {			
				var o2:Object=n.addObjectIn(o) ;			
			} else {
				n.addValueIn(o) ;			
			}			
			n.addAttributeIn(o);	
			var hasArray:Boolean=n._hasArray;
			var hasObject:Boolean=n._hasObject;
			if (hasObject && hasArray) {
				alert("A node has Array AND Object at the same time : No possible !");
				return;
			}
			var arr:Array=n._childNode ; var len=arr.length ;
			for (var i=0;i<len;i++) {			
				if (hasArray) { 
					arr2[i]={};
					o=arr2[i];
					o.isElem = true;//used in Node class					
				} else 	if (n._hasObject) { 
					o=o2;
				}
				toObject(arr[i],o,tab);
			}
			
		}

		
	}//End of Class Model
}
