﻿/**
* Manage a Node 
* @see XmlParser
* @author Jean-Michel Delettre (jm.delettre@flash-line.net)
* @link http://www.flash-line.net
*/ 
package net.flash_line.as3.util.xml {
	import net.flash_line.as3.util.common.* ; 	
	import net.flash_line.as3.util.global.* ;
	import flash.xml.XMLNode ;
	//
	class Node extends Super {
		private var pNode:XML;
		private var pLen :Number;
/**
* constructor
* @param	vNode 
*/
		public function Node (vNode:XML) {
			pNode=vNode ;
			pLen=pNode.children().length() ;
			setClassInfo("Node",this);	
			
		}
/**
* getter/setter
*/
		public function get _node () : XML {return pNode;}			
		public function get _len () : Number {return pLen;}			
		public function get _attribute () :Object {	return pNode.attributes(); }	
		public function get _id () :String {return  pNode.localName();}
		public function get _hasObject () :Boolean {	
			 return ( pLen>0 && getValue()==null && (!_hasArray)  ) ;
		};	
		public function get _hasArray () :Boolean {		
			// Warning in this version :
			// If an Object has an Array, it can embed only one array
			// and not else Object or Array in the same time.
			// Nevertheless it may have attributes -or properties.
			var cpt:Number=0;var testLen:Number=Math.min(pLen,5);
			for (var i:Number = 0; i<testLen ; i++ ) {				
				if (pNode.children()[0].localName()==pNode.children()[i].localName()) cpt++ ;
			}
			if (cpt==testLen && pLen>1) return true ;
			else return false ;
		}
		public function get _childNode():Array {	
			var childArr=[];		
			for (var i = 0; i<pLen; i++ ) {	
				childArr.push(new Node(pNode.children()[i]));
			}
			return childArr ;
		}		
		public function getValue():String {	
			if (pNode.hasSimpleContent() && pNode.text().toString()!="" && pNode.text()!=null) {
				return  pNode.text().toString();
			}
			else return null;
			
		}
		public function addValueIn(o:Object) {	
			if (getValue()==null) return;
			o=returnNewObject(o);
			o.val=getValue();
			
		}
		public function addArrayIn(o:Object) : Array {
			o=returnNewObject(o);
			o.arrayName = pNode.children()[0].localName();
			o[pNode.children()[0].localName()]= [] ;
			var arr:Array=o[pNode.children()[0].localName()];
			return arr ;
		}
		public function addObjectIn(o:Object) : Object {
			return returnNewObject(o);		
		}
		public function addAttributeIn(o:Object) {	
			var o2 = new Object(); var exist=false;
			for (var i:String in pNode.attributes()) { 
				o2[pNode.attributes()[i].localName()]=pNode.attributes()[i].toString() ;
				exist=true;
			}
			if (!exist) return ;
			o=returnNewObject(o);		
			for (i in o2) {	
				o[i]=o2[i];
			} 
		}
		public function returnNewObject(o:Object) {
			if (o.isElem==true && (!_hasArray) && getValue()==null) {
				return o;
			} else {
				if (o[pNode.localName()]==null) o[pNode.localName()]={};
				return o[pNode.localName()];
			}
		}
		

	//private
		
	}//End of Class Node
}
